{
Copyright 2006-2007 John T. Haller of PortableApps.com

Website: http://PortableApps.com/

This software is OSI Certified Open Source Software.
OSI Certified is a certification mark of the Open Source Initiative.

Please see the included license file for the full details on
all included components.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.


An exception to the GPL is granted to link this code to
non-GPLed DLLs published by PortableApps.com to enable advanced
functionality.
}

unit functions;

interface

uses Windows, Graphics, SysUtils;

	function HexColorToTColor (strHexColor: string) : TColor;
  procedure ShowDesktopIcons (boolShow: boolean);

implementation

function HexColorToTColor (strHexColor: string): TColor;
begin
  Result:=RGB(
      StrToInt('$'+Copy(strHexColor, 1, 2)),
      StrToInt('$'+Copy(strHexColor, 3, 2)),
      StrToInt('$'+Copy(strHexColor, 5, 2)));
end;

procedure ShowDesktopIcons (boolShow: boolean);
	var hndProgramManager: THandle;
begin
	hndProgramManager:= FindWindow('ProgMan', nil);
	hndProgramManager:= GetWindow(hndProgramManager, GW_CHILD);
  if boolShow = True then
    ShowWindow(hndProgramManager, SW_SHOW)
  else
    ShowWindow(hndProgramManager, SW_HIDE);
end;

end.
