{
Copyright 2006-2009 John T. Haller of PortableApps.com

Website: http://PortableApps.com/

This software is OSI Certified Open Source Software.
OSI Certified is a certification mark of the Open Source Initiative.

Please see the included license file for the full details on
all included components.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.


An exception to the GPL is granted to link this code to
non-GPLed DLLs published by PortableApps.com to enable advanced
functionality.
}

unit main;

interface

uses Windows, Classes, Forms, StdCtrls, Buttons, ExtCtrls, ComCtrls, Messages,
	Jpeg, ShellAPI, Controls, Graphics, Dialogs, SysUtils, INIFiles,
	StrUtils, Menus, Registry, about, variables, functions, objects,
	pngimage, XPMan;

type
	TfrmMenu = class(TForm)
    imgPortableAppsLogo: TImage;

	// === THEMING ===
	// Only a portion of the upcoming theming engine is contained here
	imgBackground: TImage;
	imgClose: TImage; // not yet used visibly but used as a clickable element
	imgDriveSpace: TImage;
	imgDocuments: TImage;
	imgMusic: TImage;
	imgPictures: TImage;
	imgVideos: TImage;
	imgExplore: TImage;

	imgDivider1: TImage;
	imgBackup: TImage;
	imgOptions: TImage;

	imgDivider2: TImage;
	imgSearch: TImage;
	imgHelp: TImage;

	// Drive name and free space display
	lblDriveName: TLabel;
	lblDriveSpace: TLabel;

	// === POPUP MENUS ===
	pmnuBackup: TPopupMenu;
    pmnuitmBackupBackup: TMenuItem;
    pmnuitmBackupRestore: TMenuItem;

	pmnuOptions: TPopupMenu;
	pmnuitmOptionsSmallFonts: TMenuItem;
	pmnuitmOptionsLargeFonts: TMenuItem;
	pmnuitmOptionsDivider: TMenuItem;
	pmnuitmOptionsAddApp: TMenuItem;
	pmnuitmOptionsGetMore: TMenuItem;
	pmnuitmOptionsRefreshApps: TMenuItem;

	pmnuSearch: TPopupMenu;
	pmnuitmSearchDrive: TMenuItem;
	pmnuitmSearchComputer: TMenuItem;
	pmnuitmSearchWeb: TMenuItem;

	// === TRAY ICON ===
	trayiconMenu: TTrayIcon;

	// === TIMERS ===
	tmrFader: TTimer;
	tmrWatchFocus: TTimer;
	opndlgAddApp: TOpenDialog;
    imgDragSpaceHidden: TImage;
    pmnuTray: TPopupMenu;
    pmnuitmTrayExit: TMenuItem;
    pmnuitmOptionsDivider2: TMenuItem;
    pmnuitmOptionsLanguage: TMenuItem;
    pmnuHelp: TPopupMenu;
    pmnuitmHelpPortableAppsSupport: TMenuItem;
    pmnuitmHelpAbout: TMenuItem;
    pmnuitmTrayDocuments: TMenuItem;
    pmnuitmTrayMusic: TMenuItem;
    pmnuitmTrayVideos: TMenuItem;
    pmnuitmTrayDivider2: TMenuItem;
    pmnuitmTrayPictures: TMenuItem;
    pmnuitmTrayExplore: TMenuItem;
    imgPersonalPicture: TImage;
    bvlPersonalPicture: TBevel;
    edtDriveName: TEdit;
    btnChangeDriveName: TButton;
    imgEject: TImage;
    imgAppButtonBackground01: TImage;
    imgAppButtonBackground02: TImage;
    imgAppButtonIcon01: TImage;
    lblAppButton01: TLabel;
    imgAppButtonBackground03: TImage;
    imgAppButtonBackground04: TImage;
    imgAppButtonBackground05: TImage;
    imgAppButtonBackground06: TImage;
    imgAppButtonBackground07: TImage;
    imgAppButtonBackground08: TImage;
    imgAppButtonBackground09: TImage;
    imgAppButtonBackground10: TImage;
    imgAppButtonBackground11: TImage;
    imgAppButtonBackground12: TImage;
    imgAppButtonBackground13: TImage;
    imgAppButtonBackground14: TImage;
    imgAppButtonBackground15: TImage;
    imgAppbuttonBackground16: TImage;
    imgAppButtonBackground17: TImage;
    imgAppbuttonBackground18: TImage;
    imgAppButtonBackground19: TImage;
    imgAppButtonBackground20: TImage;
    imgAppButtonIcon02: TImage;
    imgAppButtonIcon03: TImage;
    imgAppButtonIcon04: TImage;
    imgAppButtonIcon05: TImage;
    imgAppButtonIcon06: TImage;
    imgAppButtonIcon07: TImage;
    imgAppButtonIcon08: TImage;
    imgAppButtonIcon09: TImage;
    imgAppButtonIcon10: TImage;
    imgAppButtonIcon11: TImage;
    imgAppButtonIcon12: TImage;
    imgAppButtonIcon13: TImage;
    imgAppButtonIcon14: TImage;
    imgAppButtonIcon15: TImage;
    imgAppButtonIcon16: TImage;
    imgAppButtonIcon17: TImage;
    imgAppButtonIcon18: TImage;
    imgAppButtonIcon19: TImage;
    imgAppButtonIcon20: TImage;
    lblAppButton02: TLabel;
    lblAppButton03: TLabel;
    lblAppButton04: TLabel;
    lblAppButton05: TLabel;
    lblAppButton06: TLabel;
    lblAppButton07: TLabel;
    lblAppButton08: TLabel;
    lblAppButton09: TLabel;
    lblAppButton10: TLabel;
    lblAppButton11: TLabel;
    lblAppButton12: TLabel;
    lblAppButton13: TLabel;
    lblAppButton14: TLabel;
    lblAppButton15: TLabel;
    lblAppButton16: TLabel;
    lblAppButton17: TLabel;
    lblAppButton18: TLabel;
    lblAppButton19: TLabel;
    lblAppButton20: TLabel;
    imgAppButtonForeground01: TImage;
    imgAppButtonForeground02: TImage;
    imgAppButtonForeground03: TImage;
    imgAppButtonForeground04: TImage;
    imgAppButtonForeground05: TImage;
    imgAppButtonForeground06: TImage;
    imgAppButtonForeground07: TImage;
    imgAppButtonForeground08: TImage;
    imgAppButtonForeground09: TImage;
    imgAppButtonForeground10: TImage;
    imgAppButtonForeground11: TImage;
    imgAppButtonForeground12: TImage;
    imgAppButtonForeground13: TImage;
    imgAppButtonForeground14: TImage;
    imgAppButtonForeground15: TImage;
    imgAppButtonForeground16: TImage;
    imgAppButtonForeground17: TImage;
    imgAppButtonForeground18: TImage;
    imgAppButtonForeground19: TImage;
    imgAppButtonForeground20: TImage;
    imgButtonDocumentsBackground: TImage;
    lblButtonDocuments: TLabel;
    imgButtonDocumentsForeground: TImage;
    imgButtonMusicBackground: TImage;
    lblButtonMusic: TLabel;
    imgButtonMusicForeground: TImage;
    imgButtonPicturesBackground: TImage;
    imgButtonVideosBackground: TImage;
    imgButtonExploreBackground: TImage;
    imgButtonBackupBackground: TImage;
    imgButtonOptionsBackground: TImage;
    imgButtonSearchBackground: TImage;
    imgButtonHelpBackground: TImage;
    lblButtonPictures: TLabel;
    lblButtonVideos: TLabel;
    lblButtonExplore: TLabel;
    lblButtonBackup: TLabel;
    lblButtonOptions: TLabel;
    lblButtonSearch: TLabel;
    lblButtonHelp: TLabel;
    imgButtonPicturesForeground: TImage;
    imgButtonVideosForeground: TImage;
    imgButtonExploreForeground: TImage;
    imgButtonBackupForeground: TImage;
    imgButtonOptionsForeground: TImage;
    imgButtonSearchForeground: TImage;
    imgButtonHelpForeground: TImage;
    imgButtonScrollUp: TImage;
    imgButtonScrollDown: TImage;
    lblDriveSpaceShadow: TLabel;
    pmnuAppRightClick: TPopupMenu;
    pmnuitmAppRightClickRun: TMenuItem;
    pmnuitmAppRightClickRunAsAdmin: TMenuItem;
    pmnuitmAppRightClickDivider1: TMenuItem;
    pmnuitmAppRightClickPinToTop: TMenuItem;
    pmnuitmAppRightClickHideFromMenu: TMenuItem;
    pmnuitmAppRightClickRename: TMenuItem;
    pmnuitmAppRightClickDivider2: TMenuItem;
    pmnuitmAppRightClickShowHiddenIcons: TMenuItem;
    imgPortableAppsLogo2: TImage;
    imgDivider3: TImage;
    imgButtonOEMForeground: TImage;
    imgButtonOEMBackground: TImage;
    imgOEMButton: TImage;
    lblButtonOEM: TLabel;
    pmnuOEM: TPopupMenu;
    pmnuitmOEMHomepage: TMenuItem;
    pmnuitmOEMStore: TMenuItem;
    pmnuitmOEMSupport: TMenuItem;
    pmnuitmOptionsHideDesktopIcons: TMenuItem;
    pmnuitmHelpUpdateClick: TMenuItem;
    pmnuitmTrayTitle: TMenuItem;
    pmnuitmTrayDivider: TMenuItem;
    procedure pmnuitmHelpUpdateClickClick(Sender: TObject);
    procedure pmnuitmOptionsHideDesktopIconsClick(Sender: TObject);
    procedure pmnuitmOEMSupportClick(Sender: TObject);
    procedure pmnuitmOEMStoreClick(Sender: TObject);
    procedure pmnuitmOEMHomepageClick(Sender: TObject);
    procedure imgButtonOEMForegroundClick(Sender: TObject);
    procedure pmnuitmAppRightClickRunAsAdminClick(Sender: TObject);
    procedure pmnuitmAppRightClickRunClick(Sender: TObject);
    procedure imgButtonScrollDownClick(Sender: TObject);
    procedure imgButtonScrollUpClick(Sender: TObject);
    procedure imgButtonHelpForegroundClick(Sender: TObject);
    procedure imgButtonSearchForegroundClick(Sender: TObject);
    procedure imgButtonOptionsForegroundClick(Sender: TObject);
    procedure imgButtonBackupForegroundClick(Sender: TObject);
    procedure imgButtonExploreForegroundClick(Sender: TObject);
    procedure imgButtonVideosForegroundClick(Sender: TObject);
    procedure imgButtonPicturesForegroundClick(Sender: TObject);
    procedure imgButtonMusicForegroundClick(Sender: TObject);
    procedure imgButtonDocumentsForegroundClick(Sender: TObject);
    procedure imgBackgroundClick(Sender: TObject);
    procedure imgEjectClick(Sender: TObject);
    procedure imgEjectMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure imgEjectMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure imgEjectMouseLeave(Sender: TObject);
    procedure imgEjectMouseEnter(Sender: TObject);
    procedure imgCloseMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure imgCloseMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure imgCloseMouseLeave(Sender: TObject);
    procedure imgCloseMouseEnter(Sender: TObject);
    procedure btnChangeDriveNameClick(Sender: TObject);
    procedure imgPersonalPictureMouseLeave(Sender: TObject);
    procedure imgPersonalPictureMouseEnter(Sender: TObject);
    procedure edtDriveNameKeyPress(Sender: TObject; var Key: Char);
    procedure lblDriveNameClick(Sender: TObject);
    procedure imgPersonalPictureMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure imgPersonalPictureClick(Sender: TObject);
    procedure pmnuitmHelpAboutClick(Sender: TObject);
    procedure pmnuitmHelpPortableAppsSupportClick(Sender: TObject);
    procedure pmnuitmTrayExitClick(Sender: TObject);
    procedure imgDragSpaceHiddenMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);

	// === PROCEDURES ===
	// standard form handlers
	procedure FormCreate(Sender: TObject);
	procedure FormDestroy(Sender: TObject);
	procedure FormHotkey(var msg: TWMHotkey); message WM_HOTKEY;

	// Special handler for clicks of app icons
	procedure AppButtonMouseEnter(Sender: TObject);
	procedure AppButtonMouseLeave(Sender: TObject);
  procedure AppButtonMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);

    // Scrolling the app icon list up or down
	procedure FormMouseWheelUp(Sender: TObject; Shift: TShiftState;
		MousePos: TPoint; var Handled: Boolean);
	procedure FormMouseWheelDown(Sender: TObject; Shift: TShiftState;
		MousePos: TPoint; var Handled: Boolean);
	procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
	procedure ScrollApps(bolScrollUp: Boolean);

	// Handlers for the folder and function buttons
	procedure imgCloseClick(Sender: TObject);

	// Tray icon handler
	procedure trayiconMenuClick(Sender: TObject);

	// Display / hide the menu, fade in/out
	procedure FadeInOut(bolFadeInNow: Boolean);
	procedure tmrWatchFocusTimer(Sender: TObject);
	procedure tmrFaderTimer(Sender: TObject);

	// Popup menu handlers
	// Backup popup menu
	procedure pmnuitmBackupBackupClick(Sender: TObject);
	procedure pmnuitmBackupRestoreClick(Sender: TObject);

	// Options popup menu
	procedure pmnuitmOptionsSmallFontsClick(Sender: TObject);
	procedure pmnuitmOptionsLargeFontsClick(Sender: TObject);
	procedure pmnuitmOptionsAddAppClick(Sender: TObject);
	procedure pmnuitmOptionsRefreshAppsClick(Sender: TObject);
	procedure pmnuitmOptionsGetMoreClick(Sender: TObject);

	// Help popup menu
	procedure pmnuitmSearchWebClick(Sender: TObject);
	procedure pmnuitmSearchComputerClick(Sender: TObject);
	procedure pmnuitmSearchDriveClick(Sender: TObject);

	protected
		// Used to add a drop shadow to the menu
		procedure CreateParams(var Params: TCreateParams); override;

	private
  	iniSettingsFile: TINIFile;

		// object array of app buttons, corresponds to tstrlstApplications
    arrAppButtonBackgrounds: array [0..19] of TImage;
    arrAppButtonForegrounds: array [0..19] of TImage;
    arrAppButtonIcons: array [0..19] of TImage;
    arrAppButtonLabels: array [0..19] of TLabel;
    arrAppItems: array of TAppListItem;

		// object array of app icons, corresponds to arrAppButtons
		//arrAppIcons: array of HICON;

		// tracking variable for the currently displayer first icon
		intFirstButton: integer;
    intSelectedButton: integer;

		// tracking variables for the fade timers
		bolFadeIn: boolean; // true if fading in
		bolFadeToExit: boolean; // true if exiting on fade out
    intAlphaBlendMain: integer;

		// container variables for drive size, free space size and name
		dblDriveSize: int64;
		strDriveSize: string;
		dblDriveFree: int64;
		dblDriveUsed: int64;
		strDriveFree: string;
		strDriveName: string;

		// Variables for storing wallpaper change state
		bolWallpaperChanged: boolean;
		strWallpaperBackup: string;
		strWallpaperStyleBackup: string;
		strWallpaperTileBackup: string;
    decScreenRatio: single;

    // Locale
    strLocale: string;
    intLocaleID: integer;
    strLocaleWinName: string;
    strLocaleCode2: string;
    strLocaleCode3: string;
    strLanguageCode: string;
    strLocaleglibc: string;
		bolDisableAppLanguageSwitching: boolean;

    // Theme Internals
    imgAppButtonHover: TImage;
  	imgFolderButtonHover: TImage;
    imgScrollUpNormal: TImage;
    imgScrollUpHover: TImage;
    imgScrollDownNormal: TImage;
    imgScrollDownHover: TImage;

  	// Display
    bolLargeFonts: boolean;
    bolFadeMenu: boolean;
    bolRemainVisible: boolean;
    bolStartMinimized: boolean;
    strStartPositionHorizontal: string;
  	strStartPositionVertical: string;
    bolShadow: boolean;
		bolHideDesktopIcons: boolean;
		bolAnotherFormDisplayed: boolean;

    // OEM
    strOEM: string;

    bolPersonalPictureTransparent: boolean;

		// Internal procedures to handle the buttons and font size
		procedure ChangeMenuFontSize(intFontSize: integer);
		procedure SetupButtons();
    procedure SortButtons();
		procedure DisplayButtons();
		procedure ClearButtons();
		procedure LoadLocale();
		procedure SetupMenus();
		procedure pmnuitmLocaleClick(Sender : TObject);
		procedure LoadSettings();
		procedure SaveSettings();
		procedure OpenURL(strURL : String);

    // Handle second instance
    function WindowsMessageRecieved(var Msg : TMessage) : Boolean;
	public
		// public variable for the add app function to pass in the app to install
		strAppToInstall: string;
		strRenameMenuItem: string;
end;

  TMenuItemExtended = class(TMenuItem)
  private
    fValue: string;
  published
    property Value : string read fValue write fValue;
end;

var
	frmMenu: TfrmMenu;

implementation

uses renamemenuitem;

{$R *.dfm}

//resourcestring

procedure TfrmMenu.CreateParams(var Params: TCreateParams);
// used to display a drop shadow on the menu on WinXP and up
const
	CS_DROPSHADOW = $00020000;
begin
	inherited;
	if ((Win32MajorVersion >= 5) and (Win32MinorVersion >= 1)) OR (Win32MajorVersion >= 6) then
  begin
		Params.WindowClass.Style := Params.WindowClass.Style or CS_DROPSHADOW;
    bolShadow:=true;
  end else
  	bolShadow:=false;
end;

function TFrmMenu.WindowsMessageRecieved(var Msg : TMessage) : Boolean;
// Handle our custom 'multiple-instance' event
begin
  if Msg.Msg = RegisterWindowMessage(PAnsiChar('PortableApps.comPlatformWindowMessageToRecallInstance'+ParamStr(0))) then
  begin
    FadeInOut(true);
    result := true;
  end
  else
  begin
	  if msg.Msg = RegisterWindowMessage(PAnsiChar('PortableApps.comPlatformWindowMessageToRefresh'+ExtractFileDir(Application.ExeName)+'\App\'+ExtractFileName(Application.ExeName))) then
  	begin
			//Cde to refresh window
	    intFirstButton:=0;
 	   ClearButtons();
 	   SetupButtons();
 	   DisplayButtons();
    	result:=true;
  	end
  	else
    	result := false;
  end;
end;

procedure TFrmMenu.FormHotkey(var msg: TWMHotkey);
// handle hotkey presses
begin
	if frmMenu.Visible then
		FadeInOut(false)
	else
		FadeInOut(true);
end;

procedure TFrmMenu.FormCreate(Sender: TObject);
	const
		VK_P = $50;
	var
		//dcDesktop: HDC;
		//intColorDepth: integer;
		regControlPanel: TRegIniFile;
    iniAutorun: TINIFile;
    iniOEM: TINIFile;
    iniTheme: TINIFile;
    strAutorunFilename: string;
    strOEMFilename: string;
    osVerInfo: TOSVersionInfo;
    clrAppButtons: TColor;
    clrFolderButtons: TColor;
    clrDriveSpace: TColor;
  	clrDriveSpaceShadow: TColor;
{    bmpTemp: TBitmap;
    icoTemp: TIcon;}
begin
	if Not FileExists(PAnsiChar(ExtractFileDir(Application.ExeName) + '\Data')) then begin
    // Create the Data directory if it is missing
    ForceDirectories(PAnsiChar(ExtractFileDir(Application.ExeName) + '\Data'));
  end;
	iniSettingsFile:=TINIFile.Create(ExtractFileDir(Application.ExeName) + '\Data\PortableAppsMenu.ini');

	// Message handler
	Application.HookMainWindow(WindowsMessageRecieved);

	// Default Button State
	intFirstButton:=0;

  // Settings
  LoadSettings;

  frmMenu.Caption:='PortableApps.com Platform - '+Application.ExeName;

  // OEM Branding
  {if FileExists(PAnsiChar(ExtractFileDir(Application.ExeName)+'/OEM/oem.ini')) then begin
  	if FileExists(PAnsiChar(ExtractFileDir(Application.ExeName)+'/OEM/oemlogo_icon.png')) then begin
    	imgOEMButton.Picture.LoadFromFile(ExtractFileDir(Application.ExeName)+'/OEM/oemlogo_icon.png');
    	imgOEMButton.Visible:=true;
    	lblButtonOEM.Visible:=true;
    	imgButtonOEMForeground.visible:=true;
      imgDivider3.Visible:=true;
  	end;
    if FileExists(PAnsiChar(ExtractFileDir(Application.ExeName)+'/OEM/oemlogo_main.png')) then begin
    	imgPortableAppsLogo.Picture.LoadFromFile(ExtractFileDir(Application.ExeName)+'/OEM/oemlogo_main.png');
    	imgPortableAppsLogo2.Visible:=true;
  	end;
    strOEMFilename:= Trim(ExtractFileDir(Application.ExeName)+'/OEM/oem.ini');
	  iniOEM:=TINIFile.Create(strOEMFilename);
  	strOEM := iniOEM.ReadString('oem_information', 'oem', 'OEM');
    lblButtonOEM.Caption:=strOEM;
    if ansiLowerCase(iniOEM.ReadString('oem_menu', 'homepage', 'False'))='false' then
    	pmnuitmOEMHomepage.Visible:=False;
    if ansiLowerCase(iniOEM.ReadString('oem_menu', 'store', 'False'))='false' then
    	pmnuitmOEMStore.Visible:=False;
    if ansiLowerCase(iniOEM.ReadString('oem_menu', 'support', 'False'))='false' then
    	pmnuitmOEMSupport.Visible:=False;
	  iniOEM.Free;
  end;}
  



	// Load Theme (temporarily hard-coded to App/DefaultData until theme setup finalized)
	// **TODO - Check data directory first, add theme loader and selector
	//jpgTempImage := TJPEGImage.Create;
	//jpgTempImage.LoadFromFile(ExtractFileDir(Application.ExeName) + '/App/DefaultData/Theme/background.jpg');
	//imgBackground.Canvas.Draw(0,0,jpgTempImage);
	//jpgTempImage.Free;
	//bmpTempImage := TBitmap.Create;
	//bmpTempImage.LoadFromFile(ExtractFileDir(Application.ExeName) + '/App/DefaultData/Theme/background_top.bmp');
	//imgBackground.Canvas.Draw(0,0,bmpTempImage);
	//bmpTempImage.Free;
  osVerInfo.dwOSVersionInfoSize := SizeOf(osVerInfo);
	GetVersionEx(osVerInfo);
  if (osVerInfo.dwPlatformId<>VER_PLATFORM_WIN32_NT) and FileExists(PAnsiChar(ExtractFileDir(Application.ExeName) + '/App/DefaultData/Theme/background_opaque.png')) then
    imgBackground.Picture.LoadFromFile(ExtractFileDir(Application.ExeName) + '/App/DefaultData/Theme/background_opaque.png')
  else
    imgBackground.Picture.LoadFromFile(ExtractFileDir(Application.ExeName) + '/App/DefaultData/Theme/background.png');
	imgDriveSpace.Picture.LoadFromFile(ExtractFileDir(Application.ExeName) + '/App/DefaultData/Theme/drive_space_slider.png');
	imgEject.Picture.LoadFromFile(ExtractFileDir(Application.ExeName) + '/App/DefaultData/Theme/button_eject_normal.png');
 	imgClose.Picture.LoadFromFile(ExtractFileDir(Application.ExeName) + '/App/DefaultData/Theme/button_close_normal.png');
  imgAppButtonHover:=TImage.Create(Self);
 	imgAppButtonHover.Picture.LoadFromFile(ExtractFileDir(Application.ExeName) + '/App/DefaultData/Theme/appbutton_hover.png');
  imgFolderButtonHover:=TImage.Create(Self);
 	imgFolderButtonHover.Picture.LoadFromFile(ExtractFileDir(Application.ExeName) + '/App/DefaultData/Theme/folderbutton_hover.png');
  imgScrollUpHover:=TImage.Create(Self);
 	imgScrollUpHover.Picture.LoadFromFile(ExtractFileDir(Application.ExeName) + '/App/DefaultData/Theme/button_scrollup_hover.png');
  imgScrollUpNormal:=TImage.Create(Self);
 	imgScrollUpNormal.Picture.LoadFromFile(ExtractFileDir(Application.ExeName) + '/App/DefaultData/Theme/button_scrollup_normal.png');
  imgScrollDownHover:=TImage.Create(Self);
 	imgScrollDownHover.Picture.LoadFromFile(ExtractFileDir(Application.ExeName) + '/App/DefaultData/Theme/button_scrolldown_hover.png');
  imgScrollDownNormal:=TImage.Create(Self);
 	imgScrollDownNormal.Picture.LoadFromFile(ExtractFileDir(Application.ExeName) + '/App/DefaultData/Theme/button_scrolldown_normal.png');
  imgButtonScrollUp.Picture:=imgScrollUpNormal.Picture;
  imgButtonScrollDown.Picture:=imgScrollDownNormal.Picture;

	// Load Icons (temporarily hard-coded to App/DefaultData until theme setup finalized)
	// **TODO - Check data directory first, add icon theme loader
	imgBackup.Picture.LoadFromFile(ExtractFileDir(Application.ExeName) + '/App/DefaultData/Theme/menu_icons/backup.png');
	imgDocuments.Picture.LoadFromFile(ExtractFileDir(Application.ExeName) + '/App/DefaultData/Theme/menu_icons/documents.png');
	imgExplore.Picture.LoadFromFile(ExtractFileDir(Application.ExeName) + '/App/DefaultData/Theme/menu_icons/explore.png');
	imgHelp.Picture.LoadFromFile(ExtractFileDir(Application.ExeName) + '/App/DefaultData/Theme/menu_icons/help.png');
	imgMusic.Picture.LoadFromFile(ExtractFileDir(Application.ExeName) + '/App/DefaultData/Theme/menu_icons/music.png');
	imgOptions.Picture.LoadFromFile(ExtractFileDir(Application.ExeName) + '/App/DefaultData/Theme/menu_icons/options.png');
	imgPictures.Picture.LoadFromFile(ExtractFileDir(Application.ExeName) + '/App/DefaultData/Theme/menu_icons/pictures.png');
	imgSearch.Picture.LoadFromFile(ExtractFileDir(Application.ExeName) + '/App/DefaultData/Theme/menu_icons/search.png');
	imgVideos.Picture.LoadFromFile(ExtractFileDir(Application.ExeName) + '/App/DefaultData/Theme/menu_icons/videos.png');

  if FileExists(PAnsiChar(ExtractFileDir(Application.ExeName)+'/App/DefaultData/Theme/PATheme.ini')) then begin
  	iniTheme:=TINIFile.Create(ExtractFileDir(Application.ExeName)+'/App/DefaultData/Theme/PATheme.ini');
    clrAppButtons:=HexColorToTColor(iniTheme.ReadString('ButtonApplications', 'FontColor', '000000'));
    lblAppButton01.Font.Color:=clrAppButtons;
    lblAppButton02.Font.Color:=clrAppButtons;
    lblAppButton03.Font.Color:=clrAppButtons;
    lblAppButton04.Font.Color:=clrAppButtons;
    lblAppButton05.Font.Color:=clrAppButtons;
    lblAppButton06.Font.Color:=clrAppButtons;
    lblAppButton07.Font.Color:=clrAppButtons;
    lblAppButton08.Font.Color:=clrAppButtons;
    lblAppButton09.Font.Color:=clrAppButtons;
    lblAppButton10.Font.Color:=clrAppButtons;
    lblAppButton11.Font.Color:=clrAppButtons;
    lblAppButton12.Font.Color:=clrAppButtons;
    lblAppButton13.Font.Color:=clrAppButtons;
    lblAppButton14.Font.Color:=clrAppButtons;
    lblAppButton15.Font.Color:=clrAppButtons;
    lblAppButton16.Font.Color:=clrAppButtons;
    lblAppButton17.Font.Color:=clrAppButtons;
    lblAppButton18.Font.Color:=clrAppButtons;
    lblAppButton19.Font.Color:=clrAppButtons;
    lblAppButton20.Font.Color:=clrAppButtons;
    clrFolderButtons:=HexColorToTColor(iniTheme.ReadString('ButtonFolders', 'FontColor', 'FFFFFF'));
    lblButtonDocuments.Font.Color:=clrFolderButtons;
    lblButtonMusic.Font.Color:=clrFolderButtons;
    lblButtonPictures.Font.Color:=clrFolderButtons;
    lblButtonVideos.Font.Color:=clrFolderButtons;
    lblButtonExplore.Font.Color:=clrFolderButtons;
    lblButtonBackup.Font.Color:=clrFolderButtons;
    lblButtonOptions.Font.Color:=clrFolderButtons;
    lblButtonSearch.Font.Color:=clrFolderButtons;
    lblButtonHelp.Font.Color:=clrFolderButtons;
    lblButtonOEM.Font.Color:=clrFolderButtons;
  	clrDriveSpace:=HexColorToTColor(iniTheme.ReadString('DriveSpace', 'FontColor', 'FFFFFF'));
    lblDriveSpace.Font.Color:=clrDriveSpace;
   	clrDriveSpaceShadow:=HexColorToTColor(iniTheme.ReadString('DriveSpace', 'FontShadowColor', '888888'));
    lblDriveSpaceShadow.Font.Color:=clrDriveSpaceShadow;
    if ansiLowerCase(iniTheme.ReadString('DriveSpace', 'StretchImage', 'true'))='true' then
      imgDriveSpace.Stretch:=true
    else
			imgDriveSpace.Stretch:=false;
  end;

  // Menu icons
  {icoTemp := TIcon.Create;
  bmpTemp:=TBitmap.Create;
  icoTemp.LoadFromFile();
     try
     bmpTemp.Width := imgDocuments.Picture.Graphic.Width;
     bmpTemp.Height := imgDocuments.Picture.Graphic.Height;
     //bmpTemp.Canvas.Brush.Color:=clRed;
     bmpTemp.PixelFormat := pf24bit;
		 bmpTemp.Canvas.Draw(0, 0, imgDocuments.Picture.Graphic);
     //bmpTemp.TransparentColor:= RGB(255, 0, 0);
     pmnuitmTrayDocuments.Bitmap:=bmpTemp;
   finally
     bmpTemp.Free;
   end;}

  // Font size
  if bolLargeFonts then begin
		pmnuitmOptionsLargeFonts.Checked:=true;
		ChangeMenuFontSize(10);
  end;

	// Setup the app list
	SetupButtons;
	DisplayButtons;

	// Language
  LoadLocale();
  SetupMenus();

  // Get the drive's name from the autorun.inf
  strAutorunFilename:= Trim(ExtractFileDrive(Application.ExeName) + '\autorun.inf');
  iniAutorun:=TINIFile.Create(strAutorunFilename);
  strDriveName := iniAutorun.ReadString('Autorun', 'Label', 'Drive');
  iniAutorun.Free;
  lblDriveName.Caption:=strDriveName + ' (' + ExtractFileDrive(Application.ExeName) + ')';

	// Position our menu
	if ansiLowerCase(strStartPositionHorizontal)='left' then
		Left:= Screen.WorkAreaRect.Left
  else if ansiLowerCase(strStartPositionHorizontal)='center' then
    Left:=(Screen.WorkAreaRect.Right div 2) - (Width div 2)
  else // default to right
    Left:= Screen.WorkAreaRect.Right-Width;

	if ansiLowerCase(strStartPositionVertical)='top' then
		Top:= Screen.WorkAreaRect.Top
  else if ansiLowerCase(strStartPositionVertical)='middle' then
    Top:=(Screen.WorkAreaRect.Bottom div 2) - (Height div 2)
  else // default to bottom
		Top:= Screen.WorkAreaRect.Bottom-Height;

  // Create the window hidden and set its properties
	ShowWindow(Application.Handle, SW_HIDE);
	SetWindowLong(Application.Handle, GWL_EXSTYLE,
			GetWindowLong(Application.Handle, GWL_EXSTYLE) or WS_EX_TOOLWINDOW);

	RegisterHotkey(Handle, 1, MOD_WIN, VK_P);

  // Wallpaper
  decScreenRatio:=(Screen.Width * 1000 div Screen.Height);
  //showmessage(FormatFloat('#.####',decScreenRatio));
  if FileExists(ExtractFileDir(ExtractFileDir(ExtractFileDir(Application.ExeName)))+'\Documents\Pictures\portableapps_wallpaper.bmp') then begin
    regControlPanel:= TRegIniFile.Create('Control Panel\Desktop');
    bolWallpaperChanged:=true;
    strWallpaperBackup:=regControlPanel.ReadString('','Wallpaper','');
    strWallpaperStyleBackup:=regControlPanel.ReadString('','WallpaperStyle','');
    strWallpaperTileBackup:=regControlPanel.ReadString('','TileWallpaper','');
    if FileExists(ExtractFileDir(ExtractFileDir(ExtractFileDir(Application.ExeName)))+'\Documents\Pictures\portableapps_wallpaper_wide.bmp') then begin
    	if decScreenRatio > 1450 then
      	regControlPanel.WriteString('', 'Wallpaper', ExtractFileDir(ExtractFileDir(ExtractFileDir(Application.ExeName)))+'\Documents\Pictures\portableapps_wallpaper_wide.bmp')
    	else
				regControlPanel.WriteString('', 'Wallpaper', ExtractFileDir(ExtractFileDir(ExtractFileDir(Application.ExeName)))+'\Documents\Pictures\portableapps_wallpaper.bmp');
    end
    else
	    regControlPanel.WriteString('', 'Wallpaper', ExtractFileDir(ExtractFileDir(ExtractFileDir(Application.ExeName)))+'\Documents\Pictures\portableapps_wallpaper.bmp');
    regControlPanel.WriteString('', 'TileWallpaper', '0');
    regControlPanel.WriteString('', 'WallpaperStyle', '2');
    regControlPanel.Free;
    SystemParametersInfo(SPI_SETDESKWALLPAPER, 0, nil, SPIF_SENDWININICHANGE);
  end else
    bolWallpaperChanged:=false;

	// Display the window
	//ShowWindow(Application.Handle, SW_SHOW);
  if not bolStartMinimized then
  	FadeInOut(true);
  bolFadeToExit:=false;

  // Check for personal picture
  if FileExists(PAnsiChar(ExtractFileDir(Application.ExeName)+'/Data/PersonalPicture.bmp')) then
  begin
		imgPersonalPicture.Picture.LoadFromFile(ExtractFileDir(Application.ExeName)+'/Data/PersonalPicture.bmp');
  	bolPersonalPictureTransparent:=false;
  end
  else if FileExists(PAnsiChar(ExtractFileDir(Application.ExeName)+'/Data/PersonalPicture.jpg')) then
  begin
		imgPersonalPicture.Picture.LoadFromFile(ExtractFileDir(Application.ExeName)+'/Data/PersonalPicture.jpg');
    bolPersonalPictureTransparent:=false;
  end
  else if FileExists(PAnsiChar(ExtractFileDir(Application.ExeName)+'/Data/PersonalPicture.png')) then
  begin
		imgPersonalPicture.Picture.LoadFromFile(ExtractFileDir(Application.ExeName)+'/Data/PersonalPicture.png');
    bolPersonalPictureTransparent:=true;
    bvlPersonalPicture.Visible:=false;
  end
  else
    bvlPersonalPicture.Visible:=false;

  // Hide Desktop Icons
  if bolHideDesktopIcons then
  	ShowDesktopIcons(false)
  else
  	pmnuitmOptionsHideDesktopIcons.checked:=false;
end;

procedure TfrmMenu.FormDestroy(Sender: TObject);begin
  // Unregister our Global Hotkeys
  UnregisterHotkey(Handle, 1);

  // Unhook our message handler
  Application.UnHookMainWindow(WindowsMessageRecieved);

end;

procedure TfrmMenu.AppButtonMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  iControl : integer;
	strOriginalName : string;
	strAppPath: string;
begin
	begin
    for iControl := 0 to length(arrAppButtonForegrounds) do
	    if TObject(arrAppButtonForegrounds[iControl]) = Sender then
      	if Button = mbRight then begin
					intSelectedButton:=iControl;
					//pmnuAppRightClick.Popup(Mouse.CursorPos.X,Mouse.CursorPos.Y);
					strOriginalName:=arrAppItems[iControl+intFirstButton].Caption;
					frmRenameMenuItem.strOriginalName:=arrAppItems[iControl+intFirstButton].DefaultName;
					frmRenameMenuItem.strCustomName:=strOriginalName;
					bolAnotherFormDisplayed:=true;
					frmRenameMenuItem.ShowModal;
					bolAnotherFormDisplayed:=false;
					if strOriginalName<>frmRenameMenuItem.strCustomName then
					begin
						strAppPath:=RightStr(arrAppItems[iControl+intFirstButton].CommandLine,Length(arrAppItems[iControl+intFirstButton].CommandLine)-Length(ExtractFileDir(ExtractFileDir(Application.ExeName))+'\'));
						if frmRenameMenuItem.strCustomName='' then
						begin
							// Reset to original name
							arrAppItems[iControl+intFirstButton].Caption:=arrAppItems[iControl+intFirstButton].DefaultName;
							iniSettingsFile.DeleteKey('AppsRenamed', ansiLowerCase(strAppPath));
						end
						else if frmRenameMenuItem.strCustomName='-' then
						begin
							iniSettingsFile.DeleteKey('AppsRenamed', ansiLowerCase(strAppPath));
							iniSettingsFile.WriteString('AppsHidden',ansiLowerCase(strAppPath),'true');
							intFirstButton:=0;
							ClearButtons();
							SetupButtons();
						end
						else
						begin
							arrAppItems[iControl+intFirstButton].Caption:=frmRenameMenuItem.strCustomName;
							iniSettingsFile.WriteString('AppsRenamed',ansiLowerCase(strAppPath),frmRenameMenuItem.strCustomName);
						end;
						SortButtons;
						DisplayButtons;
					end;
				end
  			else begin
	  	    // execute the exe path that corresponds to the same index in the app array
  	  	  if (not bolRemainVisible) then FadeInOut(False);
	      	if (ssCtrl in Shift) then
		      	ShellExecute(0,'runas', PAnsiChar(arrAppItems[iControl+intFirstButton].CommandLine+#0),Nil, PAnsiChar(arrAppItems[iControl+intFirstButton].WorkingDirectory+#0), SW_SHOW)
					else
	    	  	ShellExecute(0,'open', PAnsiChar(arrAppItems[iControl+intFirstButton].CommandLine+#0),Nil, PAnsiChar(arrAppItems[iControl+intFirstButton].WorkingDirectory+#0), SW_SHOW);
				end;
  end;
end;

procedure TfrmMenu.FormMouseWheelUp(Sender: TObject; Shift: TShiftState; MousePos: TPoint; var Handled: Boolean);
// scroll the menu up when the user scrolls the mouse wheel up over the form
begin
  ScrollApps(true);
end;

procedure TfrmMenu.FormMouseWheelDown(Sender: TObject; Shift: TShiftState; MousePos: TPoint; var Handled: Boolean);
// scroll the menu down when the user scrolls the mouse wheel down over the form
begin
  ScrollApps(false);
end;

procedure TfrmMenu.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
// catch presses of the up or down arrow as an alternative means of scrolling
begin
  if HiWord(GetKeyState(VK_UP)) <> 0 then
    ScrollApps(true)
  else if HiWord(GetKeyState(VK_DOWN)) <> 0 then
      ScrollApps(false)
  else if HiWord(GetKeyState(VK_NEXT)) <> 0 then
  	begin
      ScrollApps(false);
      ScrollApps(false);
      ScrollApps(false);
      ScrollApps(false);
      ScrollApps(false);
      ScrollApps(false);
      ScrollApps(false);
      ScrollApps(false);
      ScrollApps(false);
      ScrollApps(false);
      ScrollApps(false);
      ScrollApps(false);
      ScrollApps(false);
      ScrollApps(false);
      ScrollApps(false);
      ScrollApps(false);
      ScrollApps(false);
      ScrollApps(false);
      ScrollApps(false);
    end
	else if HiWord(GetKeyState(VK_PRIOR)) <> 0 then
  	begin
  		ScrollApps(true);
      ScrollApps(true);
      ScrollApps(true);
      ScrollApps(true);
      ScrollApps(true);
      ScrollApps(true);
      ScrollApps(true);
      ScrollApps(true);
      ScrollApps(true);
      ScrollApps(true);
      ScrollApps(true);
      ScrollApps(true);
      ScrollApps(true);
      ScrollApps(true);
      ScrollApps(true);
      ScrollApps(true);
      ScrollApps(true);
      ScrollApps(true);
      ScrollApps(true)
    end;
end;

procedure TfrmMenu.ScrollApps(bolScrollUp: Boolean);
// scroll the icon list
begin
  if bolScrollUp then
  begin
    if (intFirstButton > 0) and imgButtonScrollUp.visible then
    begin
      intFirstButton:=intFirstButton-1;
      DisplayButtons();
    end
  end else begin
    if (intFirstButton < (Length(arrAppItems)-length(arrAppButtonLabels))) and imgButtonScrollDown.visible then
    begin
      intFirstButton:=intFirstButton+1;
      DisplayButtons();
    end;
  end;
  if intFirstButton >= (Length(arrAppItems)-length(arrAppButtonLabels)) then
    imgButtonScrollDown.Visible:=False
  else
    imgButtonScrollDown.Visible:=True;
  if intFirstButton = 0 then
    imgButtonScrollUp.Visible:=False
  else
    imgButtonScrollUp.Visible:=True;
end;

procedure TfrmMenu.imgBackgroundClick(Sender: TObject);
begin
		edtDriveName.Visible:=false;
		btnChangeDriveName.Visible:=false;
end;

procedure TfrmMenu.imgButtonBackupForegroundClick(Sender: TObject);
begin
  pmnuBackup.Popup(Mouse.CursorPos.X,Mouse.CursorPos.Y);
end;

procedure TfrmMenu.imgButtonDocumentsForegroundClick(Sender: TObject);
begin
  ShellExecute(0,'open', PAnsiChar(ExtractFileDir(ExtractFileDir(ExtractFileDir(Application.ExeName))) + '\Documents\' +#0), Nil, Nil, SW_SHOW);
end;

procedure TfrmMenu.imgButtonExploreForegroundClick(Sender: TObject);
begin
  ShellExecute(0,'explore', PAnsiChar(ExtractFileDrive(Application.ExeName) + '\' +#0), Nil, Nil, SW_SHOW);
end;

procedure TfrmMenu.imgButtonHelpForegroundClick(Sender: TObject);
begin
  pmnuHelp.Popup(Mouse.CursorPos.X,Mouse.CursorPos.Y);
end;

procedure TfrmMenu.imgButtonMusicForegroundClick(Sender: TObject);
begin
  ShellExecute(0,'open', PAnsiChar(ExtractFileDir(ExtractFileDir(ExtractFileDir(Application.ExeName))) + '\Documents\Music\' +#0), Nil, Nil, SW_SHOW);
end;

procedure TfrmMenu.imgButtonOEMForegroundClick(Sender: TObject);
begin
  pmnuOEM.Popup(Mouse.CursorPos.X,Mouse.CursorPos.Y);
end;

procedure TfrmMenu.imgButtonOptionsForegroundClick(Sender: TObject);
begin
  pmnuOptions.Popup(Mouse.CursorPos.X,Mouse.CursorPos.Y);
end;

procedure TfrmMenu.imgButtonPicturesForegroundClick(Sender: TObject);
begin
  ShellExecute(0,'open', PAnsiChar(ExtractFileDir(ExtractFileDir(ExtractFileDir(Application.ExeName))) + '\Documents\Pictures\' +#0), Nil, Nil, SW_SHOW);
end;

procedure TfrmMenu.imgButtonScrollDownClick(Sender: TObject);
begin
  ScrollApps(false);
end;

procedure TfrmMenu.imgButtonScrollUpClick(Sender: TObject);
begin
  ScrollApps(true);
end;

procedure TfrmMenu.imgButtonSearchForegroundClick(Sender: TObject);
begin
  pmnuSearch.Popup(Mouse.CursorPos.X,Mouse.CursorPos.Y);
end;

procedure TfrmMenu.imgButtonVideosForegroundClick(Sender: TObject);
begin
	ShellExecute(0,'open', PAnsiChar(ExtractFileDir(ExtractFileDir(ExtractFileDir(Application.ExeName))) + '\Documents\Videos\' +#0), Nil, Nil, SW_SHOW);
end;

procedure TfrmMenu.imgCloseClick(Sender: TObject);
// close the application
begin
  bolFadeToExit := true;
  FadeInOut(false);
end;

procedure TfrmMenu.imgCloseMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
 	imgClose.Picture.LoadFromFile(ExtractFileDir(Application.ExeName) + '/App/DefaultData/Theme/button_close_pressed.png');
end;

procedure TfrmMenu.imgCloseMouseEnter(Sender: TObject);
begin
 	imgClose.Picture.LoadFromFile(ExtractFileDir(Application.ExeName) + '/App/DefaultData/Theme/button_close_hover.png');
end;

procedure TfrmMenu.imgCloseMouseLeave(Sender: TObject);
begin
 	imgClose.Picture.LoadFromFile(ExtractFileDir(Application.ExeName) + '/App/DefaultData/Theme/button_close_normal.png');
end;

procedure TfrmMenu.imgCloseMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if (X > -1) and (X < imgClose.Width+1) and (Y > -1) and ( Y < imgClose.Height+1) then
		imgClose.Picture.LoadFromFile(ExtractFileDir(Application.ExeName) + '/App/DefaultData/Theme/button_close_hover.png')
  else
		imgClose.Picture.LoadFromFile(ExtractFileDir(Application.ExeName) + '/App/DefaultData/Theme/button_close_normal.png');
end;

procedure TfrmMenu.imgDragSpaceHiddenMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
const
  SC_DRAGMOVE = $F012;
begin
  if Button = mbLeft then
  begin
    ReleaseCapture;
    Perform(WM_SYSCOMMAND, SC_DRAGMOVE, 0);
  end;
end;

procedure TfrmMenu.imgEjectClick(Sender: TObject);
begin
  ShellExecute(0,'open',PChar('C:\Windows\System32\Rundll32.exe'),
  	PChar('Shell32,Control_RunDLL hotplug.dll'),PChar('C:\Windows\System32'),SW_SHOWNORMAL);
  bolFadeToExit := true;
  FadeInOut(false);
end;

procedure TfrmMenu.imgEjectMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
 	imgEject.Picture.LoadFromFile(ExtractFileDir(Application.ExeName) + '/App/DefaultData/Theme/button_eject_pressed.png');
end;

procedure TfrmMenu.imgEjectMouseEnter(Sender: TObject);
begin
 	imgEject.Picture.LoadFromFile(ExtractFileDir(Application.ExeName) + '/App/DefaultData/Theme/button_eject_hover.png');
end;

procedure TfrmMenu.imgEjectMouseLeave(Sender: TObject);
begin
 	imgEject.Picture.LoadFromFile(ExtractFileDir(Application.ExeName) + '/App/DefaultData/Theme/button_eject_normal.png');
end;

procedure TfrmMenu.imgEjectMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if (X > -1) and (X < imgEject.Width+1) and (Y > -1) and ( Y < imgEject.Height+1) then
		imgEject.Picture.LoadFromFile(ExtractFileDir(Application.ExeName) + '/App/DefaultData/Theme/button_eject_hover.png')
  else
		imgEject.Picture.LoadFromFile(ExtractFileDir(Application.ExeName) + '/App/DefaultData/Theme/button_eject_normal.png');
end;

procedure TfrmMenu.imgPersonalPictureClick(Sender: TObject);
var
  strTempFileName:string;
begin
  strTempFileName:='';
  opndlgAddApp.Filter:='Personal Picture [48x48] (*.bmp,*.jpg,*.jpeg,*.png)|*.jpg;*.jpeg;*.bmp;*.png';
  if opndlgAddApp.Execute then
  begin
    strTempFileName:=opndlgAddApp.FileName;
  end;
  if strTempFileName<>'' then
  begin
  	DeleteFile(ExtractFileDir(Application.ExeName)+'/Data/PersonalPicture.jpg');
   	DeleteFile(ExtractFileDir(Application.ExeName)+'/Data/PersonalPicture.bmp');
   	DeleteFile(ExtractFileDir(Application.ExeName)+'/Data/PersonalPicture.png');
    imgPersonalPicture.Picture:=nil;
    if ansiLowerCase(ExtractFileExt(strTempFileName))='.bmp' then
    begin
      CopyFile(PChar(strTempFileName), PChar(ExtractFileDir(Application.ExeName)+'/Data/PersonalPicture.bmp'), True);
			imgPersonalPicture.Picture.LoadFromFile(ExtractFileDir(Application.ExeName)+'/Data/PersonalPicture.bmp');
      bolPersonalPictureTransparent:=false;
    end
    else if ansiLowerCase(ExtractFileExt(strTempFileName))='.jpg' then
    begin
      CopyFile(PChar(strTempFileName), PChar(ExtractFileDir(Application.ExeName)+'/Data/PersonalPicture.jpg'), True);
			imgPersonalPicture.Picture.LoadFromFile(ExtractFileDir(Application.ExeName)+'/Data/PersonalPicture.jpg');
      bolPersonalPictureTransparent:=false;
    end
    else
    begin
      CopyFile(PChar(strTempFileName), PChar(ExtractFileDir(Application.ExeName)+'/Data/PersonalPicture.png'), True);
			imgPersonalPicture.Picture.LoadFromFile(ExtractFileDir(Application.ExeName)+'/Data/PersonalPicture.png');
      bolPersonalPictureTransparent:=true;
    end;
    bvlPersonalPicture.Visible:=not bolPersonalPictureTransparent;
  end;
end;

procedure TfrmMenu.imgPersonalPictureMouseEnter(Sender: TObject);
begin
	if (imgPersonalPicture.Picture.Graphic=nil) and  not bolPersonalPictureTransparent=false then
  	bvlPersonalPicture.Visible:=true;
end;

procedure TfrmMenu.imgPersonalPictureMouseLeave(Sender: TObject);
begin
	if (imgPersonalPicture.Picture.Graphic=nil) or bolPersonalPictureTransparent then
  	bvlPersonalPicture.Visible:=false;
end;

procedure TfrmMenu.imgPersonalPictureMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
	if Button = mbRight then
  begin
		imgPersonalPicture.Picture:=nil;
    bvlPersonalPicture.Visible:=false;
   	DeleteFile(ExtractFileDir(Application.ExeName)+'/Data/PersonalPicture.jpg');
   	DeleteFile(ExtractFileDir(Application.ExeName)+'/Data/PersonalPicture.bmp');
   	DeleteFile(ExtractFileDir(Application.ExeName)+'/Data/PersonalPicture.png');
  end;
end;

procedure TfrmMenu.lblDriveNameClick(Sender: TObject);
begin
	edtDriveName.Text:=strDriveName;
	edtDriveName.Visible:=true;
  btnChangeDriveName.Visible:=true;
  edtDriveName.SetFocus;
end;

procedure TfrmMenu.trayiconMenuClick(Sender: TObject);
// show/hide the menu on a tray icon click
begin
  if frmMenu.Visible then begin
    FadeInOut(false);
  end else begin
    FadeInOut(true);
  end;
end;

procedure TfrmMenu.FadeInOut(bolFadeInNow: Boolean);
// fade the menu in or out and recalculate the drive size on a fade in
begin
  if bolFadeInNow then begin
    // position at the bottom right with space for the shadow
    //Top:= Screen.WorkAreaRect.Bottom-Height-4;
    //Left:= Screen.WorkAreaRect.Right-Width-4;

    // calculate and display the drive size
    dblDriveSize := DiskSize(Ord(Application.ExeName[1]) - $40);
    if dblDriveSize > 1073741824 then
      strDriveSize := FloatToStrF((dblDriveSize/1073741824), ffFixed, 4, 1) + 'GB'
    else
      if dblDriveSize > 1048576 then
        strDriveSize := FloatToStrF((dblDriveSize/1048576), ffFixed, 4, 1) + 'MB'
      else
        if dblDriveSize > 1024 then
          strDriveSize := FloatToStrF((dblDriveSize/1024), ffFixed, 4, 1) + 'KB'
        else
          strDriveSize := FloatToStrF((dblDriveSize), ffFixed, 4, 1) + 'B';

		dblDriveFree := DiskFree(Ord(Application.ExeName[1]) - $40);
    dblDriveUsed := dblDriveSize - dblDriveFree;

    if dblDriveFree > 1073741824 then
    	if (dblDriveFree/1073741824)<100 then
	      strDriveFree := FloatToStrF((dblDriveFree/1073741824), ffFixed, 4, 1) + 'GB'
      else
				strDriveFree := FloatToStrF((dblDriveFree/1073741824), ffFixed, 4, 1) + 'GB'
    else
      if dblDriveFree > 1048576 then
      	if (dblDriveFree/1048576)<100 then
	        strDriveFree := FloatToStrF((dblDriveFree/1048576), ffFixed, 4, 1) + 'MB'
        else
 	        strDriveFree := FloatToStrF((dblDriveFree/1048576), ffFixed, 4, 1) + 'MB'
      else
        if dblDriveUsed > 1024 then
        	if (dblDriveFree/1024)<100 then
	          strDriveFree := FloatToStrF((dblDriveFree/1024), ffFixed, 4, 1) + 'KB'
          else
 	          strDriveFree := FloatToStrF((dblDriveFree/1024), ffFixed, 4, 1) + 'KB'
        else
        	if dblDriveFree<100 then
	          strDriveFree := FloatToStrF((dblDriveFree), ffFixed, 4, 1) + 'B'
          else
	          strDriveFree := FloatToStrF((dblDriveFree), ffFixed, 4, 1) + 'B';

    //lblDriveSpace.Caption:= strDriveFree + ' free of ' + strDriveSize;
		lblDriveSpace.Caption:= strDriveFree + ' / ' + strDriveSize;
    lblDriveSpaceShadow.Caption:=lblDriveSpace.Caption;
		trayiconMenu.Hint:='PortableApps.com Platform'+#13#10+ strDriveName + ' ('+ExtractFileDrive(Application.ExeName)+')'+#13#10+lblDriveSpace.Caption;
    imgDriveSpace.Width:=round(dblDriveUsed/dblDriveSize*131);

    // fade in now
    bolFadeIn:= True;
    tmrFader.Enabled:= True;
		frmMenu.Show;
		SetFocus;
		SetActiveWindow(Handle);
		SetForegroundWindow(Handle);
  end else begin // fade the menu out
    bolFadeIn:= False;
    tmrFader.Enabled:= True;
 		edtDriveName.Visible:=false;
		btnChangeDriveName.Visible:=false;
  end;
end;

procedure TfrmMenu.tmrWatchFocusTimer(Sender: TObject);
begin
  if (getFocus() = 0) and (not bolRemainVisible) then FadeInOut(False);
end;

procedure TfrmMenu.tmrFaderTimer(Sender: TObject);
// adjust the alpha values to fade the menu in or out
var
  regControlPanel: TRegIniFile;
begin
  if bolFadeIn then
  begin
    if ((frmMenu.AlphaBlendValue + 30) < intAlphaBlendMain) and bolFadeMenu then
 	  begin
     	frmMenu.AlphaBlendValue := frmMenu.AlphaBlendValue + 30;
    end else begin
 	    frmMenu.AlphaBlendValue := intAlphaBlendMain;
   	  tmrFader.Enabled:= False;
    end;
  end else begin
    if (frmMenu.AlphaBlendValue > 30) and bolFadeMenu then
    begin
      frmMenu.AlphaBlendValue := frmMenu.AlphaBlendValue - 30;
    end else begin
      frmMenu.AlphaBlendValue := 0;
      frmMenu.Hide;
      tmrFader.Enabled:= False;
      if bolFadeToExit then // Exit the app on fade out if set to
      begin
        // Wallpaper TEST
        if bolWallpaperChanged=true then begin
        regControlPanel:= TRegIniFile.Create('Control Panel\Desktop');
        regControlPanel.WriteString('', 'Wallpaper', strWallpaperBackup);
        regControlPanel.WriteString('', 'TileWallpaper', strWallpaperTileBackup);
        regControlPanel.WriteString('', 'WallpaperStyle', strWallpaperStyleBackup);
        regControlPanel.Free;
        SystemParametersInfo(SPI_SETDESKWALLPAPER, 0, nil, SPIF_SENDWININICHANGE);
        end;
        	if bolHideDesktopIcons then
						ShowDesktopIcons(true);
        SaveSettings;
        iniSettingsFile.UpdateFile();
				iniSettingsFile.Free();
        Close;
      end;
    end;
  end;
end;

procedure TfrmMenu.pmnuitmAppRightClickRunAsAdminClick(Sender: TObject);
begin
  if (not bolRemainVisible) then FadeInOut(False);
	ShellExecute(0,'runas', PAnsiChar(arrAppItems[intSelectedButton+intFirstButton].CommandLine+#0),Nil, PAnsiChar(arrAppItems[intSelectedButton+intFirstButton].WorkingDirectory+#0), SW_SHOW);

end;

procedure TfrmMenu.pmnuitmAppRightClickRunClick(Sender: TObject);
begin
  if (not bolRemainVisible) then FadeInOut(False);
	ShellExecute(0,'open', PAnsiChar(arrAppItems[intSelectedButton+intFirstButton].CommandLine+#0),Nil, PAnsiChar(arrAppItems[intSelectedButton+intFirstButton].WorkingDirectory+#0), SW_SHOW);
end;

procedure TfrmMenu.pmnuitmBackupBackupClick(Sender: TObject);
// Start PortableApps Backup
begin
  ShellExecute(0,'open', PAnsiChar(ExtractFileDir(Application.ExeName) + '\PortableAppsBackup.exe'), Nil, Nil, SW_SHOWNORMAL);
end;

procedure TfrmMenu.pmnuitmHelpAboutClick(Sender: TObject);
begin
	bolAnotherFormDisplayed:=true;
	frmAbout.ShowModal;
	bolAnotherFormDisplayed:=false;
end;

procedure TfrmMenu.pmnuitmHelpPortableAppsSupportClick(Sender: TObject);
begin
  OpenURL('http://portableapps.com/support');
end;

procedure TfrmMenu.pmnuitmHelpUpdateClickClick(Sender: TObject);
begin
	OpenURL('http://portableapps.com/update?platform='+APPVERSION);
end;

procedure TfrmMenu.pmnuitmBackupRestoreClick(Sender: TObject);
// Start PortableApps Backup - Restore
begin
  ShellExecute(0,'open', PAnsiChar(ExtractFileDir(Application.ExeName) + '\PortableAppsBackupRestore.exe'), Nil, Nil, SW_SHOWNORMAL);
end;

procedure TfrmMenu.pmnuitmOptionsSmallFontsClick(Sender: TObject);
// Switch to small fonts
begin
  pmnuitmOptionsSmallFonts.Checked:=true;
  ChangeMenuFontSize(8);
  bolLargeFonts:=False;
end;

procedure TfrmMenu.pmnuitmOptionsLargeFontsClick(Sender: TObject);
// Switch to large fonts
begin
  pmnuitmOptionsLargeFonts.Checked:=true;
  ChangeMenuFontSize(10);
  bolLargeFonts:=true;
end;

procedure TfrmMenu.pmnuitmOEMHomepageClick(Sender: TObject);
begin
  OpenURL('http://redirect.portableapps.com/oem/?oem='+strOEM+'&lang='+IntToStr(intLocaleID)+'&link=home');
end;

procedure TfrmMenu.pmnuitmOEMStoreClick(Sender: TObject);
begin
	OpenURL('http://redirect.portableapps.com/oem/?oem='+strOEM+'&lang='+IntToStr(intLocaleID)+'&link=store');
end;

procedure TfrmMenu.pmnuitmOEMSupportClick(Sender: TObject);
begin
	OpenURL('http://redirect.portableapps.com/oem/?oem='+strOEM+'&lang='+IntToStr(intLocaleID)+'&link=support');
end;

procedure TfrmMenu.pmnuitmOptionsAddAppClick(Sender: TObject);
// Add an app
var
	strPortableAppsPath: string;
	procInstaller: TProcessInformation;
	startInstaller: TStartupInfo;
begin
	strAppToInstall:='';
	opndlgAddApp.Filter :=
	'PortableApps.com Format (*.paf.exe)|*.paf.exe';
	if opndlgAddApp.Execute then
	begin
		frmMenu.strAppToInstall:=opndlgAddApp.FileName;
	end;
	if strAppToInstall<>'' then
	begin
		strPortableAppsPath := ExtractFileDir(ExtractFileDir(Application.ExeName))+'\';

    FillChar(procInstaller, sizeof(TProcessInformation), 0);
    FillChar(startInstaller, sizeof(TStartupInfo), 0);
    startInstaller.cb := sizeof(TStartupInfo);

  	ShellExecute(0,'open', PAnsiChar('"' + strAppToInstall + '"'+#0),PAnsiChar(' -o"' + strPortableAppsPath + '" -y -/SILENT=YES /DESTINATION="' + strPortableAppsPath+'"'+#0), PAnsiChar(ExtractFileDir(strAppToInstall)+#0), SW_SHOW);
    {if CreateProcess(nil, PAnsiChar('"' + strAppToInstall + '" -o"' + strPortableAppsPath + '" -y -/SILENT=YES /DESTINATION="' + strPortableAppsPath+'"'+#0), nil,
      nil, false, NORMAL_PRIORITY_CLASS, nil, nil,
      startInstaller, procInstaller) <> False then
    begin
      WaitForSingleObject(procInstaller.hProcess, INFINITE);
      CloseHandle(procInstaller.hThread);
      CloseHandle(procInstaller.hProcess);
    end
    else
      ShowMessage('Could not execute ' + strAppToInstall);}

    // Install done, refresh icons
  	strAppToInstall:='';
    {intFirstButton:=0;
    ClearButtons();
    SetupButtons();
    DisplayButtons();}
  end;
end;

procedure TfrmMenu.pmnuitmOptionsRefreshAppsClick(Sender: TObject);
// Refresh apps list
begin
		intFirstButton:=0;
		ClearButtons();
		SetupButtons();
    DisplayButtons();
end;

procedure TfrmMenu.pmnuitmOptionsGetMoreClick(Sender: TObject);
// Get more applications
begin
  OpenURL('http://portableapps.com/apps');
end;

procedure TfrmMenu.pmnuitmOptionsHideDesktopIconsClick(Sender: TObject);
begin
	if bolHideDesktopIcons then
  begin
     bolHideDesktopIcons:=false;
     ShowDesktopIcons(true);
     pmnuitmOptionsHideDesktopIcons.Checked:=false;
  end
  else
  begin
     bolHideDesktopIcons:=true;
     ShowDesktopIcons(false);
     pmnuitmOptionsHideDesktopIcons.Checked:=true;
  end;
end;

procedure TfrmMenu.pmnuitmSearchDriveClick(Sender: TObject);
// Open windows search for this drive
begin
  ShellExecute(0,'find', PAnsiChar(ExtractFileDrive(Application.ExeName) + '\' +#0), Nil, Nil, SW_SHOW);
end;

procedure TfrmMenu.pmnuitmSearchComputerClick(Sender: TObject);
// Open windows search for the drive containing the WINDIR
var
  strWinDir: string;
begin
  strWinDir := GetEnvironmentVariable('WINDIR');
  ShellExecute(0,'find', PAnsiChar(ExtractFileDrive(strWinDir) + '\' +#0), Nil, Nil, SW_SHOW);
end;

procedure TfrmMenu.pmnuitmSearchWebClick(Sender: TObject);
// Open a web search in Firefox Portable
begin
  OpenURL('http://start.portableapps.com/');
end;

procedure TfrmMenu.pmnuitmTrayExitClick(Sender: TObject);
begin
  bolFadeToExit := true;
  FadeInOut(false);
end;

procedure TfrmMenu.AppButtonMouseEnter(Sender: TObject);
// Special handler for the app button hovers
var
  intControl : integer;
  bolDone: boolean;
begin
	bolDone:=false;

  for intControl := 0 to length(arrAppButtonForegrounds) do
  begin
    if TObject(arrAppButtonForegrounds[intControl]) = Sender then
    begin
      arrAppButtonBackgrounds[intControl].Picture:=imgAppButtonHover.Picture;
      bolDone:=true;
    end;
  end;

  if not bolDone then
    if imgButtonDocumentsForeground = Sender then
  		imgButtonDocumentsBackground.Picture:=imgFolderButtonHover.Picture
		else if imgButtonMusicForeground = Sender then
			imgButtonMusicBackground.Picture:=imgFolderButtonHover.Picture
    else if imgButtonPicturesForeground = Sender then
  		imgButtonPicturesBackground.Picture:=imgFolderButtonHover.Picture
    else if imgButtonVideosForeground = Sender then
  		imgButtonVideosBackground.Picture:=imgFolderButtonHover.Picture
    else if imgButtonExploreForeground = Sender then
  		imgButtonExploreBackground.Picture:=imgFolderButtonHover.Picture
    else if imgButtonBackupForeground = Sender then
  		imgButtonBackupBackground.Picture:=imgFolderButtonHover.Picture
    else if imgButtonOptionsForeground = Sender then
  		imgButtonOptionsBackground.Picture:=imgFolderButtonHover.Picture
    else if imgButtonSearchForeground = Sender then
  		imgButtonSearchBackground.Picture:=imgFolderButtonHover.Picture
    else if imgButtonHelpForeground = Sender then
  		imgButtonHelpBackground.Picture:=imgFolderButtonHover.Picture
    else if imgButtonScrollUp = Sender then
  		imgButtonScrollUp.Picture:=imgScrollUpHover.Picture
    else if imgButtonScrollDown = Sender then
			imgButtonScrollDown.Picture:=imgScrollDownHover.Picture
    else if imgButtonOEMForeground = Sender then
    	imgButtonOEMForeground.Picture:=imgFolderButtonHover.Picture;
end;

procedure TfrmMenu.AppButtonMouseLeave(Sender: TObject);
// Special handler for the app button hovers
var
  intControl : integer;
  bolDone: boolean;
begin
	bolDone:=false;

  for intControl := 0 to length(arrAppButtonForegrounds) do
  begin
    if TObject(arrAppButtonForegrounds[intControl]) = Sender then
    begin
      arrAppButtonBackgrounds[intControl].Picture:=nil;
      bolDone:=true;
    end;
  end;

  if not bolDone then
	  if imgButtonDocumentsForeground = Sender then
  		imgButtonDocumentsBackground.Picture:=nil
    else if imgButtonMusicForeground = Sender then
  		imgButtonMusicBackground.Picture:=nil
    else if imgButtonPicturesForeground = Sender then
  		imgButtonPicturesBackground.Picture:=nil
    else if imgButtonVideosForeground = Sender then
  		imgButtonVideosBackground.Picture:=nil
    else if imgButtonExploreForeground = Sender then
  		imgButtonExploreBackground.Picture:=nil
    else if imgButtonBackupForeground = Sender then
  		imgButtonBackupBackground.Picture:=nil
    else if imgButtonOptionsForeground = Sender then
  		imgButtonOptionsBackground.Picture:=nil
    else if imgButtonSearchForeground = Sender then
  		imgButtonSearchBackground.Picture:=nil
    else if imgButtonHelpForeground = Sender then
  		imgButtonHelpBackground.Picture:=nil
  	else if imgButtonScrollUp = Sender then
  		imgButtonScrollUp.Picture:=imgScrollUpNormal.Picture
   	else if imgButtonScrollDown = Sender then
  		imgButtonScrollDown.Picture:=imgScrollDownNormal.Picture
    else if imgButtonOEMForeground = Sender then
    	imgButtonOEMForeground.Picture:=nil;
                                                
end;

procedure TfrmMenu.btnChangeDriveNameClick(Sender: TObject);
var
    iniAutorun: TINIFile;
    strAutorunFilename: string;
begin
	strDriveName:=edtDriveName.Text;
	lblDriveName.Caption:=strDriveName + ' (' + ExtractFileDrive(Application.ExeName) + ')';
	strAutorunFilename:= Trim(ExtractFileDrive(Application.ExeName) + '\autorun.inf');
	iniAutorun:=TINIFile.Create(strAutorunFilename);
	iniAutorun.WriteString ('Autorun','Label',strDriveName);
	iniAutorun.Free;
	edtDriveName.Visible:=false;
	btnChangeDriveName.Visible:=false;
end;

procedure TfrmMenu.ChangeMenuFontSize(intFontSize: integer);
// Change the font size of the menu components
begin
  lblAppButton01.font.size:=intFontSize;
  lblAppButton02.font.size:=intFontSize;
  lblAppButton03.font.size:=intFontSize;
	lblAppButton04.font.size:=intFontSize;
	lblAppButton05.font.size:=intFontSize;
	lblAppButton06.font.size:=intFontSize;
	lblAppButton07.font.size:=intFontSize;
	lblAppButton08.font.size:=intFontSize;
	lblAppButton09.font.size:=intFontSize;
	lblAppButton10.font.size:=intFontSize;
	lblAppButton11.font.size:=intFontSize;
	lblAppButton12.font.size:=intFontSize;
	lblAppButton13.font.size:=intFontSize;
	lblAppButton14.font.size:=intFontSize;
	lblAppButton15.font.size:=intFontSize;
	lblAppButton16.font.size:=intFontSize;
	lblAppButton17.font.size:=intFontSize;
	lblAppButton18.font.size:=intFontSize;
	lblAppButton19.font.size:=intFontSize;
	lblAppButton20.font.size:=intFontSize;
  lblButtonDocuments.font.size:=intFontSize;
  lblButtonMusic.font.size:=intFontSize;
  lblButtonPictures.font.size:=intFontSize;
  lblButtonVideos.font.size:=intFontSize;
  lblButtonExplore.font.size:=intFontSize;
  lblButtonBackup.font.size:=intFontSize;
  lblButtonOptions.font.size:=intFontSize;
  lblButtonHelp.font.size:=intFontSize;
  lblButtonSearch.font.size:=intFontSize;
end;

procedure TfrmMenu.LoadLocale();
var
	iniLocaleFile: TINIFile;
begin
	// Check for locale test file
	// Temporary addition to allow testing of .locale files for translations
	if FileExists(ExtractFileDir(Application.ExeName)+'\App\Locale\'+strLocale+'.locale') then
	begin
		iniLocaleFile:=TINIFile.Create(ExtractFileDir(Application.ExeName)+'\App\Locale\'+strLocale+'.locale');
  	if not bolDisableAppLanguageSwitching then begin
  	  intLocaleID:=StrToInt(iniLocaleFile.ReadString('PortableApps.comLocaleDetails', 'LocaleID', '1033'));
	    strLocaleWinName:=iniLocaleFile.ReadString('PortableApps.comLocaleDetails', 'LocaleWinName', 'LANG_ENGLISH');
    	strLocaleCode2:=iniLocaleFile.ReadString('PortableApps.comLocaleDetails', 'LocaleCode2', 'en');
	    strLocaleCode3:=iniLocaleFile.ReadString('PortableApps.comLocaleDetails', 'LocaleCode3', 'eng');
  	  strLanguageCode:=iniLocaleFile.ReadString('PortableApps.comLocaleDetails', 'LanguageCode', 'en-us');
	  	strLocaleglibc:=iniLocaleFile.ReadString('PortableApps.comLocaleDetails', 'Localeglibc', 'en-us');
    end;
		lblButtonDocuments.Caption:=iniLocaleFile.ReadString('FORM_MAIN', 'ICON_DOCUMENTS', '&Documents');
		lblButtonMusic.Caption:=iniLocaleFile.ReadString('FORM_MAIN', 'ICON_MUSIC', '&Music');
		lblButtonPictures.Caption:=iniLocaleFile.ReadString('FORM_MAIN', 'ICON_PICTURES', '&Pictures');
		lblButtonVideos.Caption:=iniLocaleFile.ReadString('FORM_MAIN', 'ICON_VIDEOS', '&Videos');
		lblButtonExplore.Caption:=iniLocaleFile.ReadString('FORM_MAIN', 'ICON_EXPLORE', '&Explore');
		lblButtonBackup.Caption:=iniLocaleFile.ReadString('FORM_MAIN', 'ICON_BACKUP', '&Backup');
		lblButtonOptions.Caption:=iniLocaleFile.ReadString('FORM_MAIN', 'ICON_OPTIONS', '&Options');
		lblButtonHelp.Caption:=iniLocaleFile.ReadString('FORM_MAIN', 'ICON_HELP', '&Help');
		lblButtonSearch.Caption:=iniLocaleFile.ReadString('FORM_MAIN', 'ICON_SEARCH', '&Search');
		pmnuitmOptionsSmallFonts.Caption:=iniLocaleFile.ReadString('FORM_MAIN', 'MENU_OPTIONS_SMALL_FONTS', '&Small Fonts');
		pmnuitmOptionsLargeFonts.Caption:=iniLocaleFile.ReadString('FORM_MAIN', 'MENU_OPTIONS_LARGE_FONTS', '&Large Fonts');
		pmnuitmOptionsAddApp.Caption:=iniLocaleFile.ReadString('FORM_MAIN', 'MENU_OPTIONS_ADD_APP', '&Install a New App');
		pmnuitmOptionsRefreshApps.Caption:=iniLocaleFile.ReadString('FORM_MAIN', 'MENU_OPTIONS_REFRESH_ICONS', '&Refresh App Icons');
		pmnuitmOptionsGetMore.Caption:=iniLocaleFile.ReadString('FORM_MAIN', 'MENU_OPTIONS_GET_APPS', '&Get More Apps...');
		pmnuitmOptionsLanguage.Caption:=iniLocaleFile.ReadString('FORM_MAIN', 'MENU_OPTIONS_LANGUAGE', 'L&anguage');
		pmnuitmBackupBackup.Caption:=iniLocaleFile.ReadString('FORM_MAIN', 'MENU_BACKUP', '&Backup Files');
		pmnuitmBackupRestore.Caption:=iniLocaleFile.ReadString('FORM_MAIN', 'MENU_RESTORE', '&Restore From Backup');
		pmnuitmHelpAbout.Caption:=iniLocaleFile.ReadString('FORM_MAIN', 'MENU_HELP_ABOUT', '&About');
  	pmnuitmHelpAbout.Caption:=pmnuitmHelpAbout.Caption+' PortableApps.com Menu';
		pmnuitmSearchDrive.Caption:=iniLocaleFile.ReadString('FORM_MAIN', 'MENU_SEARCH_DRIVE', 'Search This &Drive');
		pmnuitmSearchComputer.Caption:=iniLocaleFile.ReadString('FORM_MAIN', 'MENU_SEARCH_COMPUTER', 'Search This &Computer');
		pmnuitmSearchWeb.Caption:=iniLocaleFile.ReadString('FORM_MAIN', 'MENU_SEARCH_WEB', 'Search The &Web');
    pmnuitmOEMHomepage.Caption:=iniLocaleFile.ReadString('FORM_MAIN', 'MENU_HOMEPAGE', '&Homepage');
    pmnuitmOEMStore.Caption:=iniLocaleFile.ReadString('FORM_MAIN', 'MENU_STORE', 'S&tore');
    pmnuitmOEMSupport.Caption:=iniLocaleFile.ReadString('FORM_MAIN', 'MENU_SUPPORT', '&Support');
		pmnuitmTrayExit.Caption:=iniLocaleFile.ReadString('FORM_MAIN', 'MENU_TRAY_EXIT', 'E&xit');
		strRenameMenuItem:=iniLocaleFile.ReadString('FORM_RENAME_MENU_ITEM', 'CAPTION', 'Rename');
		iniLocaleFile.Free;

    // Shared strings
    pmnuitmTrayDocuments.Caption:=lblButtonDocuments.Caption;
    pmnuitmTrayMusic.Caption:=lblButtonMusic.Caption;
    pmnuitmTrayPictures.Caption:=lblButtonPictures.Caption;
    pmnuitmTrayVideos.Caption:=lblButtonVideos.Caption;
    pmnuitmTrayExplore.Caption:=lblButtonExplore.Caption;

    // Environment Variables
    SetEnvironmentVariable(PChar('PortableApps.comLocaleID'), PChar(IntToStr(intLocaleID)));
    SetEnvironmentVariable(PChar('PortableApps.comLocaleWinName'), PChar(strLocaleWinName));
		SetEnvironmentVariable(PChar('PortableApps.comLocaleCode2'), PChar(strLocaleCode2));
		SetEnvironmentVariable(PChar('PortableApps.comLocaleCode3'), PChar(strLocaleCode3));
 		SetEnvironmentVariable(PChar('PortableApps.comLanguageCode'), PChar(strLanguageCode));
 		SetEnvironmentVariable(PChar('PortableApps.comLocaleglibc'), PChar(strLocaleglibc));

	end;
end;

procedure TfrmMenu.OpenURL (strURL: String);
// opens a web address
begin
  if FileExists(ExtractFileDir(ExtractFileDir(Application.ExeName)) + '\FirefoxPortable\FirefoxPortable.exe') then
	  ShellExecute(0,'open', PAnsiChar(ExtractFileDir(ExtractFileDir(Application.ExeName)) + '\FirefoxPortable\FirefoxPortable.exe'), PAnsiChar(strURL), Nil, SW_SHOWNORMAL)
  else
  	ShellExecute(self.WindowHandle,'open',PChar(strURL),nil,nil, SW_SHOWNORMAL);;
end;

procedure TfrmMenu.SetupMenus();
// Set up the language menu
// Acknowledgement: http://delphi.about.com/od/kbcurt/a/dynamicmenuitem.htm for the handy tutorial
var
  pmnuitmTemp: TMenuItemExtended;
  tsrchDirectory: TSearchRec;
begin
  // Clear the menus
  pmnuitmOptionsLanguage.Clear;
  // Set up locale menu
  if FindFirst(ExtractFileDir(Application.ExeName) + '\App\Locale\*.locale',faAnyFile,tsrchDirectory)=0 then
  begin
    repeat
      pmnuitmTemp:=TMenuItemExtended.Create(pmnuitmOptionsLanguage);
      pmnuitmTemp.Value:=ExtractFileDir(Application.ExeName) + '\App\Locale\' + tsrchDirectory.FindData.cFileName;
      pmnuitmTemp.Caption:=LeftStr(ExtractFileName(pmnuitmTemp.Value), Length(ExtractFileName(pmnuitmTemp.Value))-7);
      pmnuitmTemp.OnClick:=pmnuitmLocaleClick;
      pmnuitmTemp.RadioItem:=True;
      // If it's the currently enabled locale, enable it's menu option
      if AnsiLowerCase(pmnuitmTemp.Caption)=AnsiLowerCase(strLocale) then
        pmnuitmTemp.Checked:=true;
      pmnuitmOptionsLanguage.Add(pmnuitmTemp);
    Until FindNext(tsrchDirectory)<>0;
    FindClose(tsrchDirectory);
  end
  else
  begin
    // Insert dummy item to make it look like a submenu
    pmnuitmTemp:=TMenuItemExtended.Create(pmnuitmOptionsLanguage);
    pmnuitmOptionsLanguage.Add(pmnuitmTemp);
    pmnuitmOptionsLanguage.Enabled:=False;
  end;
end;

procedure TfrmMenu.pmnuitmLocaleClick(Sender : TObject);
// Click handler for the locale menu
begin
  //Get the locale name from the menu caption

  strLocale:=StringReplace(TMenuItemExtended(Sender).Caption, '&', '', [rfReplaceAll, rfIgnoreCase]);
  TMenuItemExtended(Sender).Checked:=true;
  // ShowMessage(strLocale);
  LoadLocale();
end;

procedure TFrmMenu.LoadSettings ();
begin
		if ansiLowerCase(iniSettingsFile.ReadString('DisplayOptions', 'LargeFonts', 'False'))='false' then
    	bolLargeFonts:=False
    else
    	bolLargeFonts:=True;
 		if ansiLowerCase(iniSettingsFile.ReadString('DisplayOptions', 'FadeMenu', 'False'))='false' then
    	bolFadeMenu:=False
    else
    	bolFadeMenu:=True;
 		if ansiLowerCase(iniSettingsFile.ReadString('DisplayOptions', 'HideDesktopIcons', 'False'))='false' then
    	bolHideDesktopIcons:=False
    else
    	bolHideDesktopIcons:=True;
 		if ansiLowerCase(iniSettingsFile.ReadString('DisplayOptions', 'RemainVisible', 'False'))='false' then
    	bolRemainVisible:=False
    else
    	bolRemainVisible:=True;
 		if ansiLowerCase(iniSettingsFile.ReadString('DisplayOptions', 'StartMinimized', 'False'))='false' then
    	bolStartMinimized:=False
    else
    	bolStartMinimized:=True;
 		if ansiLowerCase(iniSettingsFile.ReadString('Localization', 'DisableAppLanguageSwitching', 'False'))='true' then
    	bolDisableAppLanguageSwitching:=True
    else
    	bolDisableAppLanguageSwitching:=False;
 		intAlphaBlendMain:=iniSettingsFile.ReadInteger('DisplayOptions', 'AlphaBlendMain', 255);
		strLocale:=iniSettingsFile.ReadString('DisplayOptions', 'Language', 'English');
 		strStartPositionHorizontal:=iniSettingsFile.ReadString('DisplayOptions', 'StartPositionHorizontal', 'Right');
 		strStartPositionVertical:=iniSettingsFile.ReadString('DisplayOptions', 'StartPositionVertical', 'Bottom');
end;

procedure TFrmMenu.SaveSettings ();
var
  strEndPositionHorizontal: String;
  strEndPositionVertical: String;
begin
  if bolLargeFonts then
	  iniSettingsFile.WriteString('DisplayOptions', 'LargeFonts', 'True')
  else
	  iniSettingsFile.WriteString('DisplayOptions', 'LargeFonts', 'False');
  if bolHideDesktopIcons then
	  iniSettingsFile.WriteString('DisplayOptions', 'HideDesktopIcons', 'True')
  else
	  iniSettingsFile.WriteString('DisplayOptions', 'HideDesktopIcons', 'False');
  iniSettingsFile.WriteString('DisplayOptions', 'Language', strLocale);

  // Figure out menu position
  if Left < screen.WorkAreaRect.Left+100 then
  	strEndPositionHorizontal:='Left'
  else if Left > Screen.WorkAreaRect.Right-Width-100 then
  	strEndPositionHorizontal:='Right'
  else if (Left > (Screen.WorkAreaRect.Right div 2) - (Width div 2) - 200) and (Left < (Screen.WorkAreaRect.Right div 2) - (Width div 2) + 200) then
  	strEndPositionHorizontal:='Center'
  else
  	strEndPositionHorizontal:=strStartPositionHorizontal;

  if Top < screen.WorkAreaRect.Top+100 then
  	strEndPositionVertical:='Top'
  else if Top > Screen.WorkAreaRect.Bottom-Height-100 then
  	strEndPositionVertical:='Bottom'
  else if (Top > (Screen.WorkAreaRect.Bottom div 2) - (Height div 2) - 200) and (Top < (Screen.WorkAreaRect.Bottom div 2) - (Height div 2) + 200) then
  	strEndPositionVertical:='Middle'
  else
  	strEndPositionVertical:=strStartPositionVertical;

	iniSettingsFile.WriteString('DisplayOptions', 'StartPositionHorizontal', strEndPositionHorizontal);
	iniSettingsFile.WriteString('DisplayOptions', 'StartPositionVertical', strEndPositionVertical);
  iniSettingsFile.WriteInteger('DisplayOptions', 'AlphaBlendMain', intAlphaBlendMain);

  iniSettingsFile.UpdateFile();
end;

procedure TFrmMenu.SetupButtons();
// Search for the installed apps and index them in the list and button arrays
var
	strPortableAppsPath: String;
	tsrchDirectory: TSearchRec;
	tsrchSubDirectory: TSearchRec;
	strTempSubDir: String;
	strCurrentAppName: String;
	strCurrentAppPath: String;
	//intCounter: integer;
	ptrFileInfo: pointer;
	lngFileInfoSize: Longint;
	dwdFileInfoLength: DWORD;
	ptrFileInfoLanguage : Pointer;
	ptrFileInfoData: Pointer;
	strFileInfoQuery: String;
	uintFileInfoDataLength: Uint;
	//FileInfo: TSHFileInfo;
  //ticoTemp: TIcon;
  hicoLarge: Hicon;
  hicoSmall: Hicon;
	intCounter, intMin, intLook, intPAFIcons, intPAFIconCounter: integer;
	TempAppListItem: TAppListItem;
	iniAppInfo: TINIFile;
	strPAFPublisher, strPAFPackageVersion, strPAFDisplayVersion, strPortableAppName: string;
	strPAFStart: string;
begin
	strPortableAppsPath:= ExtractFileDir(ExtractFileDir(Application.ExeName))+'\';

  // Setup Buttons
  arrAppButtonLabels[0]:=lblAppButton01;
  arrAppButtonLabels[1]:=lblAppButton02;
  arrAppButtonLabels[2]:=lblAppButton03;
  arrAppButtonLabels[3]:=lblAppButton04;
  arrAppButtonLabels[4]:=lblAppButton05;
  arrAppButtonLabels[5]:=lblAppButton06;
  arrAppButtonLabels[6]:=lblAppButton07;
  arrAppButtonLabels[7]:=lblAppButton08;
  arrAppButtonLabels[8]:=lblAppButton09;
  arrAppButtonLabels[9]:=lblAppButton10;
  arrAppButtonLabels[10]:=lblAppButton11;
  arrAppButtonLabels[11]:=lblAppButton12;
  arrAppButtonLabels[12]:=lblAppButton13;
  arrAppButtonLabels[13]:=lblAppButton14;
  arrAppButtonLabels[14]:=lblAppButton15;
  arrAppButtonLabels[15]:=lblAppButton16;
  arrAppButtonLabels[16]:=lblAppButton17;
  arrAppButtonLabels[17]:=lblAppButton18;
  arrAppButtonLabels[18]:=lblAppButton19;
  arrAppButtonLabels[19]:=lblAppButton20;

  arrAppButtonBackgrounds[0]:=imgAppButtonBackground01;
  arrAppButtonBackgrounds[1]:=imgAppButtonBackground02;
  arrAppButtonBackgrounds[2]:=imgAppButtonBackground03;
  arrAppButtonBackgrounds[3]:=imgAppButtonBackground04;
  arrAppButtonBackgrounds[4]:=imgAppButtonBackground05;
  arrAppButtonBackgrounds[5]:=imgAppButtonBackground06;
  arrAppButtonBackgrounds[6]:=imgAppButtonBackground07;
  arrAppButtonBackgrounds[7]:=imgAppButtonBackground08;
  arrAppButtonBackgrounds[8]:=imgAppButtonBackground09;
  arrAppButtonBackgrounds[9]:=imgAppButtonBackground10;
  arrAppButtonBackgrounds[10]:=imgAppButtonBackground11;
  arrAppButtonBackgrounds[11]:=imgAppButtonBackground12;
  arrAppButtonBackgrounds[12]:=imgAppButtonBackground13;
  arrAppButtonBackgrounds[13]:=imgAppButtonBackground14;
  arrAppButtonBackgrounds[14]:=imgAppButtonBackground15;
  arrAppButtonBackgrounds[15]:=imgAppButtonBackground16;
  arrAppButtonBackgrounds[16]:=imgAppButtonBackground17;
  arrAppButtonBackgrounds[17]:=imgAppButtonBackground18;
  arrAppButtonBackgrounds[18]:=imgAppButtonBackground19;
  arrAppButtonBackgrounds[19]:=imgAppButtonBackground20;

  arrAppButtonForegrounds[0]:=imgAppButtonForeground01;
  arrAppButtonForegrounds[1]:=imgAppButtonForeground02;
  arrAppButtonForegrounds[2]:=imgAppButtonForeground03;
  arrAppButtonForegrounds[3]:=imgAppButtonForeground04;
  arrAppButtonForegrounds[4]:=imgAppButtonForeground05;
  arrAppButtonForegrounds[5]:=imgAppButtonForeground06;
  arrAppButtonForegrounds[6]:=imgAppButtonForeground07;
  arrAppButtonForegrounds[7]:=imgAppButtonForeground08;
  arrAppButtonForegrounds[8]:=imgAppButtonForeground09;
  arrAppButtonForegrounds[9]:=imgAppButtonForeground10;
  arrAppButtonForegrounds[10]:=imgAppButtonForeground11;
  arrAppButtonForegrounds[11]:=imgAppButtonForeground12;
  arrAppButtonForegrounds[12]:=imgAppButtonForeground13;
  arrAppButtonForegrounds[13]:=imgAppButtonForeground14;
  arrAppButtonForegrounds[14]:=imgAppButtonForeground15;
  arrAppButtonForegrounds[15]:=imgAppButtonForeground16;
  arrAppButtonForegrounds[16]:=imgAppButtonForeground17;
  arrAppButtonForegrounds[17]:=imgAppButtonForeground18;
  arrAppButtonForegrounds[18]:=imgAppButtonForeground19;
  arrAppButtonForegrounds[19]:=imgAppButtonForeground20;

  arrAppButtonIcons[0]:=imgAppButtonIcon01;
  arrAppButtonIcons[1]:=imgAppButtonIcon02;
  arrAppButtonIcons[2]:=imgAppButtonIcon03;
	arrAppButtonIcons[3]:=imgAppButtonIcon04;
  arrAppButtonIcons[4]:=imgAppButtonIcon05;
  arrAppButtonIcons[5]:=imgAppButtonIcon06;
  arrAppButtonIcons[6]:=imgAppButtonIcon07;
  arrAppButtonIcons[7]:=imgAppButtonIcon08;
  arrAppButtonIcons[8]:=imgAppButtonIcon09;
  arrAppButtonIcons[9]:=imgAppButtonIcon10;
	arrAppButtonIcons[10]:=imgAppButtonIcon11;
  arrAppButtonIcons[11]:=imgAppButtonIcon12;
  arrAppButtonIcons[12]:=imgAppButtonIcon13;
  arrAppButtonIcons[13]:=imgAppButtonIcon14;
  arrAppButtonIcons[14]:=imgAppButtonIcon15;
  arrAppButtonIcons[15]:=imgAppButtonIcon16;
  arrAppButtonIcons[16]:=imgAppButtonIcon17;
  arrAppButtonIcons[17]:=imgAppButtonIcon18;
  arrAppButtonIcons[18]:=imgAppButtonIcon19;
  arrAppButtonIcons[19]:=imgAppButtonIcon20;

	// process each directory 'next to' the PortableApps.com directory
	If FindFirst(strPortableAppsPath+'*',faAnyFile,tsrchDirectory)=0 Then
	begin
		Repeat
			If ((tsrchDirectory.Attr And faDirectory)<>0) Then
			begin
				strTempSubDir:=tsrchDirectory.FindData.cFileName;
				// Filter out the parent, current, PortableApps.com directories
				if (strTempSubDir <> '.') and (strTempSubDir <> '..') and (strTempSubDir <> 'PortableApps.com') then
				begin
					If FileExists(strPortableAppsPath + strTempSubDir + '\' + 'App\AppInfo\appinfo.ini') then
					begin
						// PortableApps.com Format App
						strCurrentAppPath:=strPortableAppsPath + strTempSubDir;
						iniAppInfo:=TINIFile.Create(strCurrentAppPath + '\' + 'App\AppInfo\appinfo.ini');
						strPortableAppName:=iniAppInfo.ReadString('Details', 'Name', '[PAF Error - Missing Name]');
						strPAFPublisher:=iniAppInfo.ReadString('Details', 'Publisher', '');
						strPAFDisplayVersion:=iniAppInfo.ReadString('Version', 'DisplayVersion', '');
						strPAFPackageVersion:=iniAppInfo.ReadString('Version', 'PackageVersion', '');
						intPAFIcons:=iniAppInfo.ReadInteger('Control', 'Icons', 1);

						if intPAFIcons=1 then
						begin
							strPAFStart:=iniAppInfo.ReadString('Control', 'Start', '[PAF Error - Missing Start]');
							if (not iniSettingsFile.ValueExists('AppsHidden',ansiLowerCase(strTempSubDir+'\'+strPAFStart))) then
							begin
								SetLength(arrAppItems, Length(arrAppItems)+1);
								arrAppItems[Length(arrAppItems)-1]:=TAppListItem.Create;
								arrAppItems[Length(arrAppItems)-1].CommandLine:=strCurrentAppPath + '\' + strPAFStart;
								arrAppItems[Length(arrAppItems)-1].WorkingDirectory:=strCurrentAppPath;
								arrAppItems[Length(arrAppItems)-1].DefaultName:=iniAppInfo.ReadString('Details', 'Name', '[PAF Error - Missing Name]');
								arrAppItems[Length(arrAppItems)-1].PortableAppName:=arrAppItems[Length(arrAppItems)-1].DefaultName;
								arrAppItems[Length(arrAppItems)-1].Publisher:=strPAFPublisher;
								arrAppItems[Length(arrAppItems)-1].PackageVersion:=strPAFPackageVersion;
								arrAppItems[Length(arrAppItems)-1].DisplayVersion:=strPAFDisplayVersion;

								if iniSettingsFile.ValueExists('AppsRenamed',LowerCase(strTempSubDir+'\'+strPAFStart)) then
									arrAppItems[Length(arrAppItems)-1].Caption:=iniSettingsFile.ReadString('AppsRenamed',LowerCase(strTempSubDir+'\'+strPAFStart),arrAppItems[Length(arrAppItems)-1].DefaultName)
								else
									arrAppItems[Length(arrAppItems)-1].Caption:=arrAppItems[Length(arrAppItems)-1].DefaultName;

								ExtractIconEx(PChar(strCurrentAppPath + '\' + 'App\AppInfo\appicon.ico'), 0, hicoLarge, hicoSmall, 1);
								arrAppItems[Length(arrAppItems)-1].Icon:=TIcon.Create;
								if hicoSmall > 1 then
									arrAppItems[Length(arrAppItems)-1].Icon.Handle:=hicoSmall
								else
									arrAppItems[Length(arrAppItems)-1].Icon.Handle:=0;
							end;
						end
						else
						begin
								for intPAFIconCounter := 1 to intPAFIcons do
								begin
									strPAFStart:=iniAppInfo.ReadString('Control', 'Start' + IntToStr(intPAFIconCounter), '[PAF Error - Missing Start]');
									if not iniSettingsFile.ValueExists('AppsHidden',LowerCase(strTempSubDir+'\'+strPAFStart)) then
									begin
										SetLength(arrAppItems, Length(arrAppItems)+1);
										arrAppItems[Length(arrAppItems)-1]:=TAppListItem.Create;
										arrAppItems[Length(arrAppItems)-1].CommandLine:=strCurrentAppPath + '\' + strPAFStart;
										arrAppItems[Length(arrAppItems)-1].WorkingDirectory:=strCurrentAppPath;
										arrAppItems[Length(arrAppItems)-1].DefaultName:=iniAppInfo.ReadString('Control', 'Name' + IntToStr(intPAFIconCounter), '[PAF Error - Missing Name]');
										arrAppItems[Length(arrAppItems)-1].PortableAppName:=strPortableAppName;
										arrAppItems[Length(arrAppItems)-1].Publisher:=strPAFPublisher;
										arrAppItems[Length(arrAppItems)-1].PackageVersion:=strPAFPackageVersion;
										arrAppItems[Length(arrAppItems)-1].DisplayVersion:=strPAFDisplayVersion;

										if iniSettingsFile.ValueExists('AppsRenamed',LowerCase(strTempSubDir+'\'+strPAFStart)) then
											arrAppItems[Length(arrAppItems)-1].Caption:=iniSettingsFile.ReadString('AppsRenamed',LowerCase(strTempSubDir+'\'+strPAFStart),arrAppItems[Length(arrAppItems)-1].DefaultName)
										else
											arrAppItems[Length(arrAppItems)-1].Caption:=arrAppItems[Length(arrAppItems)-1].DefaultName;

										ExtractIconEx(PChar(strCurrentAppPath + '\' + 'App\AppInfo\appicon' + IntToStr(intPAFIconCounter) + '.ico'), 0, hicoLarge, hicoSmall, 1);
										arrAppItems[Length(arrAppItems)-1].Icon:=TIcon.Create;
										if hicoSmall > 1 then
											arrAppItems[Length(arrAppItems)-1].Icon.Handle:=hicoSmall
										else
											arrAppItems[Length(arrAppItems)-1].Icon.Handle:=0;
									end;
								end;
						end;
						iniAppInfo.Free;
					end
					else
					begin
						// process each EXE in the current subdirectory
						If FindFirst(strPortableAppsPath+tsrchDirectory.FindData.cFileName+'\*.exe',faAnyFile,tsrchSubDirectory)=0 Then
						begin
							Repeat
							// Ensure it's a directory and not an uninstaller
							If (LowerCase(tsrchSubDirectory.FindData.cFileName) <> 'uninstall.exe') AND NOT iniSettingsFile.ValueExists('AppsHidden',LowerCase(strTempSubDir)+'\'+LowerCase(tsrchSubDirectory.FindData.cFileName)) AND ((tsrchSubDirectory.Attr And faDirectory)=0) Then
								begin
									// Store our current EXE for use
									strCurrentAppPath:=strPortableAppsPath+tsrchDirectory.FindData.cFileName+'\'+tsrchSubDirectory.FindData.cFileName;
									strCurrentAppName:='';

									if StrCurrentAppName='' then
									begin
										// Ensure that the current file has file info associated
										lngFileInfoSize:=GetFileVersionInfoSize(PChar(strCurrentAppPath), dwdFileInfoLength);
										if (lngFileInfoSize > 0) then
										begin
											GetMem(ptrFileInfo, lngFileInfoSize);
											try
												// Check if the current app has a ProductName
												if GetFileVersionInfo(PChar(strCurrentAppPath), dwdFileInfoLength, lngFileInfoSize, ptrFileInfo) then
													begin
														strFileInfoQuery:='ProductName';
														if VerQueryValue(ptrFileInfo,'\VarFileInfo\Translation',ptrFileInfoLanguage, uintFileInfoDataLength) then
															strFileInfoQuery:=Format('\StringFileInfo\%0.4x%0.4x\%s'#0,[LoWord(LongInt(ptrFileInfoLanguage^)),
																HiWord(LongInt(ptrFileInfoLanguage^)), strFileInfoQuery]);
														if VerQueryValue(ptrFileInfo,PChar(strFileInfoQuery),ptrFileInfoData,uintFileInfoDataLength) then
																strCurrentAppName:=strPas(ptrFileInfoData);
													end;
												finally
													FreeMem(ptrFileInfo, lngFileInfoSize);
											end;
										end;
										if strCurrentAppName='' then
										begin
											GetMem(ptrFileInfo, lngFileInfoSize);
											try
												// Check if the current app has a FileDescription
												if GetFileVersionInfo(PChar(strCurrentAppPath), dwdFileInfoLength, lngFileInfoSize, ptrFileInfo) then
												begin
													strFileInfoQuery:='FileDescription';
													if VerQueryValue(ptrFileInfo,'\VarFileInfo\Translation',ptrFileInfoLanguage, uintFileInfoDataLength) then
														strFileInfoQuery:=Format('\StringFileInfo\%0.4x%0.4x\%s'#0,[LoWord(LongInt(ptrFileInfoLanguage^)),
																HiWord(LongInt(ptrFileInfoLanguage^)), strFileInfoQuery]);
													if VerQueryValue(ptrFileInfo,PChar(strFileInfoQuery),ptrFileInfoData,uintFileInfoDataLength) then
														strCurrentAppName := strPas(ptrFileInfoData);
													end;
											finally
												FreeMem(ptrFileInfo, lngFileInfoSize);
											end;
										end;
									end;
									// If still no App Name, use the filename without the .exe
									if strCurrentAppName='' then
									begin
										strCurrentAppName:=tsrchSubDirectory.FindData.cFileName;
										strCurrentAppName:=LeftStr(strCurrentAppName,length(strCurrentAppName)-4);
									end;

									SetLength(arrAppItems, Length(arrAppItems)+1);
									arrAppItems[Length(arrAppItems)-1]:=TAppListItem.Create;
									arrAppItems[Length(arrAppItems)-1].CommandLine:=strCurrentAppPath;
									arrAppItems[Length(arrAppItems)-1].WorkingDirectory:=ExtractFileDir(strCurrentAppPath);
									arrAppItems[Length(arrAppItems)-1].Caption:=strCurrentAppName;
									arrAppItems[Length(arrAppItems)-1].DefaultName:=strCurrentAppName;

									// Check for renamed app
									arrAppItems[Length(arrAppItems)-1].Caption:=iniSettingsFile.ReadString('AppsRenamed',RightStr(strCurrentAppPath,(Length(strCurrentAppPath)-Length((strPortableAppsPath)))),strCurrentAppName);

									ExtractIconEx(PChar(strCurrentAppPath), 0, hicoLarge, hicoSmall, 1);
									arrAppItems[Length(arrAppItems)-1].Icon:=TIcon.Create;
									if hicoSmall > 1 then
										arrAppItems[Length(arrAppItems)-1].Icon.Handle:=hicoSmall
									else
										arrAppItems[Length(arrAppItems)-1].Icon.Handle:=0;

								end;
							Until FindNext(tsrchSubDirectory)<>0;
							FindClose(tsrchSubDirectory);
						End;
					End;
				End;
			end;
			Until FindNext(tsrchDirectory)<>0;
			FindClose(tsrchDirectory);
	end;

	// Sort the applications into alphabetical order
	for intCounter:=0 to Length(arrAppItems)-1 do begin
  	intMin:=intCounter;
		for intLook:=intCounter+1 to Length(arrAppItems)-1 do
			if ansiLowerCase(arrAppItems[intLook].Caption)<ansiLowerCase(arrAppItems[intMin].Caption) then intMin:=intLook;
				TempAppListItem:=arrAppItems[intMin];
        arrAppItems[intMin]:=arrAppItems[intCounter];
			arrAppItems[intCounter]:=TempAppListItem;
		end;


	// If we have more applications that app icon positions, enable scrolling
	if Length(arrAppItems) > Length( arrAppButtonLabels ) then
		imgButtonScrollDown.Visible:=True;
end;

procedure TfrmMenu.SortButtons();
var
	intCounter : integer;
  intMin : integer;
  intLook : integer;
  	TempAppListItem: TAppListItem;
begin
	// Sort the applications into alphabetical order
  for intCounter:=0 to Length(arrAppItems)-1 do begin
  	intMin:=intCounter;
		for intLook:=intCounter+1 to Length(arrAppItems)-1 do
			if ansiLowerCase(arrAppItems[intLook].Caption)<ansiLowerCase(arrAppItems[intMin].Caption) then intMin:=intLook;
				TempAppListItem:=arrAppItems[intMin];
        arrAppItems[intMin]:=arrAppItems[intCounter];
			arrAppItems[intCounter]:=TempAppListItem;
		end;
end;

procedure TfrmMenu.DisplayButtons();
// Draw the icons onto the menu buttons
var
	intCurrentButton: integer;
begin
	// Loop through the set of buttons
	for intCurrentButton := 0 to length(arrAppButtonLabels)-1 do
	begin
		// If we have an app for this button...
		if intCurrentButton < length(arrAppItems) then
		begin
			// Ensure the button is visible
			arrAppButtonLabels[intCurrentButton].Visible:= True;
    	arrAppButtonBackgrounds[intCurrentButton].Visible:= True;
			arrAppButtonForegrounds[intCurrentButton].Visible:= True;
			arrAppButtonIcons[intCurrentButton].Visible:= True;

			// Set caption to the name and hint to the location
			arrAppButtonLabels[intCurrentButton].Caption:=arrAppItems[intCurrentButton+intFirstButton].Caption;
			arrAppButtonIcons[intCurrentButton].Picture.Assign(arrAppItems[intCurrentButton+intFirstButton].Icon);
			//* TODO - Add the full name and version once PAF format support is complete
			if arrAppItems[intCurrentButton+intFirstButton].Publisher<>'' then
				arrAppButtonForegrounds[intCurrentButton].Hint:=arrAppItems[intCurrentButton+intFirstButton].PortableAppName + ' ' + arrAppItems[intCurrentButton+intFirstButton].DisplayVersion + ' [' + arrAppItems[intCurrentButton+intFirstButton].PackageVersion + ']' + #13#10 + arrAppItems[intCurrentButton+intFirstButton].Publisher+#13#10+arrAppItems[intCurrentButton+intFirstButton].WorkingDirectory
			else
				arrAppButtonForegrounds[intCurrentButton].Hint:=arrAppItems[intCurrentButton+intFirstButton].WorkingDirectory;

		end else
    begin
			// hide the button if we have no app for it
			arrAppButtonLabels[intCurrentButton].Visible:= False;
    	arrAppButtonBackgrounds[intCurrentButton].Visible:= False;
			arrAppButtonForegrounds[intCurrentButton].Visible:= False;
     	arrAppButtonIcons[intCurrentButton].Visible:= False;
    end;
	end;
end;

procedure TfrmMenu.edtDriveNameKeyPress(Sender: TObject; var Key: Char);
begin
  if HiWord(GetKeyState(VK_ESCAPE)) <> 0 then
  begin
		edtDriveName.Visible:=false;
		btnChangeDriveName.Visible:=false;
  end
  else if HiWord(GetKeyState(VK_RETURN)) <> 0 then
  begin
	  Key := #0;
   	btnChangeDriveName.Click;
  end;
end;

procedure TfrmMenu.ClearButtons();
// Clear out our set of icons and release the associated memory
var
	intCounter: integer;
begin
	// Destroy each icon in the array
	for intCounter:=0 to Length(arrAppItems) - 1 do
	  arrAppItems[intCounter].Icon:=nil;

  SetLength(arrAppItems,0);

	// Reset Scroll Buttons
	imgButtonScrollUp.Visible:=false;
	imgButtonScrollDown.Visible:=false;
end;

// ... and that's all folks... (aka app end)
end.
