unit objects;

interface

uses
	Windows, Graphics, ExtCtrls;

type
	TAppListItem = class(TObject)
  	private
    	strCaption: string;
			strDefaultName: string;
			strPortableAppName: string;
			strCommandLine: string;
			strWorkingDirectory: string;
			strPublisher: string;
			strPackageVersion: string;
			strDisplayVersion: string;
      icoAppIcon: TIcon;
  	public
			Property Caption: String Read strCaption Write strCaption;
			Property DefaultName: String Read strDefaultName Write strDefaultName;
			Property PortableAppName: String Read strPortableAppName Write strPortableAppName;
			Property CommandLine: String Read strCommandLine Write strCommandLine;
      Property WorkingDirectory: String Read strWorkingDirectory Write strWorkingDirectory;
      Property Publisher: String Read strPublisher Write strPublisher;
			Property PackageVersion: String Read strPackageVersion Write strPackageVersion;
 			Property DisplayVersion: String Read strDisplayVersion Write strDisplayVersion;
      Property Icon: TIcon Read icoAppIcon Write icoAppIcon;
  end;

implementation

end.
